;
;
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        start
       db  8000h-60h dup(0)
; this area is used by the resident and passthrough versions
;
;
; this data is used by the passthru program only
;
start  proc  near
;
; copy f000:0e000  for 2000h to this program
        push  ds
        mov  ax,0f800h
        mov  ds,ax
        mov  si,0
        mov  ax,cs
        add  ax,6
        mov  es,ax
        mov  di,0
        mov  cx,4000h
        cld
        rep  movsw
        pop  ds
; redirect interrupts here
        mov  ax,0
        mov  es,ax
        mov  dx,cs
        add  dx,6
        sub  dx,0800h
        mov  cx,80h  ; bottom 128 ints
        mov  di,2
        cli
iloop:
        cmp  word ptr es:[di],0f000h
        jne  not_bios
        push  es
        pop   es
        mov  word ptr es:[di],dx
not_bios:
        add  di,4
        loop iloop
;
        sti
        lea   dx,start  ; don't make the install portion resident
        int 27h
start    endp
last_byte equ this byte
CSEG        ENDS
        END        ENTPT
