;
;
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        start
       db  8000h-60h dup(0)
; this area is used by the resident and passthrough versions
;
;
; this data is used by the passthru program only
;
start  proc  near
;
; copy c800:0000  for bp to this program
        push  ds
        mov  ax,0c800h
        mov  ds,ax
        mov  bp,word ptr ds:[2] ; length of segment
        mov  cl,5
        shl  bp,cl  ; size of rom in bytes - save it
        cmp  bp,0
        jg   ok_len
        pop  ds
        int  20h
ok_len:
        mov  si,0
        mov  ax,cs
        add  ax,6
        mov  es,ax
        mov  di,0
        mov  cx,bp
        cld
        rep  movsb
        pop  ds
; redirect interrupts here
        mov  ax,0
        mov  es,ax
        mov  dx,cs
        add  dx,6
        mov  cx,80h  ; bottom 128 ints
        mov  di,2
        cli
iloop:
        cmp  word ptr es:[di],0c800h
        jne  not_bios
        push  es
        pop   es
        mov  word ptr es:[di],dx
not_bios:
        add  di,4
        loop iloop
;
        sti
        mov   dx,bp
        add   dx,60h
        int 27h
start    endp
last_byte equ this byte
CSEG        ENDS
        END        ENTPT
