public pscreen,p_gotac
public printerc,force_gra
extrn psemaphore:byte,int5:dword,epsone1:byte,epsone2:byte
extrn getcurs:near,blip:near,blop:near,semaphore:byte,prtsc:byte
public  psresol
cseg segment byte public 'CODE'
     assume cs:cseg,ds:cseg,es:cseg
SCRDUMP  PROC  NEAR
resol     db  '*t'
psresol   db  '075R'
startrast db  '*r0A'
transrast db  '*b80W'
          db  0
endrast   db  '*rB'
comprast  db  '&a+2V'
          db  0
printerc  dw 0
savess    dw  0
savesp    dw  0
stack     dw  64 dup(0)
epsone1s  db  0
pscreen:
        push ax
        mov  al,1
lock    xchg cs:psemaphore,al
        cmp  al,1
        je   no_dump
;determine if its a graphics screen
        push  bx
        mov  ah,15
        int  10h
        pop  bx
; ah has mode
; al has coloumns
; bh has page
        cmp  al,4
        jl   gotoint5
        cmp  al,6
        jg   gotoint5
        jmp  p_gotac
gotoint5:
        pop  ax
        cli
        mov  cs:psemaphore,0
        jmp  cs:int5
no_dump:
        pop  ax
        iret
force_gra:
; forces a graphics dump
        push ax
        mov  al,1
lock    xchg cs:psemaphore,al
        cmp  al,1
        je   no_dump
p_gotac:
; save the world
        cmp  cs:prtsc,0
        je  gotoint5
        mov  cs:savess,ss
        mov  cs:savesp,sp
        mov  ax,cs
        cli
        mov  ss,ax
        mov  sp,offset cs:stack+124
        sti
        push bx
        push cx
        push dx
        push si
        push di
        push ds
        push es
; get the p so others won't be messed up
        mov  ax,cs
        mov  ds,ax
        mov  es,ax
; first get the cursor location
        call getcurs
; set up resolution
        mov   comprast+4,'1'
        cmp   psresol,'1'
        je    p_nochar
        mov   comprast+4,'2'
p_nochar:
        call blip
        call crlf
startdump:
; we have a dump, the page is bhpage and the mode is in ahmode
;
; send raster graphics mode command to printerc
;
; set up start of color screen in es
; and length in cx
;
; turn off epson emulation
        mov  al,epsone1
        mov  epsone1s,al
        mov  epsone1,0
        mov  cx,100   ; number of graphics rows
        mov  bx,0     ; line number currently printing
        mov  ax,0b800h
        mov  es,ax
        mov  dx,printerc
getrow:
        push cx
        call  pset
        mov  cx,80
        mov  bx,0
gr1:
        mov  al,byte ptr es:[bx]
        mov  ah,0
        int  17h
        inc  bx
        loop gr1
        call eset
        call pset
        mov  cx,80
        mov  bx,0
gr2:
        mov  al,byte ptr es:[bx]
        mov  ah,0
        int  17h
        inc  bx
        loop gr2
        call eset
        call pset
        mov  cx,80
        mov  bx,0
gr3:
        mov  al,byte ptr es:[bx+02000h]
        mov  ah,0
        int  17h
        inc  bx
        loop gr3
        call eset
        call pset
        mov  cx,80
        mov  bx,0
gr4:
        mov  al,byte ptr es:[bx+02000h]
        mov  ah,0
        int  17h
        inc  bx
        loop gr4
        call eset
        call xorit
        pop  cx
        mov  ax,es
        add  ax,5
        mov  es,ax
        loop getrow
        mov  cx,100   ; number of graphics rows
        mov  bx,0     ; line number currently printing
        mov  ax,0b800h
        mov  es,ax
unxor:
        push cx
        call xorit
        mov  ax,es
        add  ax,5
        mov  es,ax
        pop  cx
        loop unxor
exit_dump:
        mov  al,epsone1s
        mov  epsone1,al
        call crlf
        call blop
        pop  es
        pop  ds
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        cli
        mov  ss,cs:savess
        mov  sp,cs:savesp
        sti
        mov   cs:psemaphore,0
        pop   ax
        iret
SCRDUMP      ENDP
xorit   proc  near
        mov  cx,80
        mov  bx,0
xr4:
        xor  byte ptr es:[bx],0ffh
        xor  byte ptr es:[bx+02000h],0ffh
        inc  bx
        loop xr4
       ret
xorit  endp
pzero  proc near
        mov  dx,printerc
tloop:
        lodsb
        cmp  al,0
        je  pzer_return
        mov  ah,0
        int  17h
        jmp   tloop
pzer_return:
       ret
pzero  endp
eset   proc  near
        mov  cx,4
        lea  si,endrast
        call pzero
        ret
eset    endp
pset    proc  near
        lea  si,resol
        call pzero
        ret
pset    endp
pcrlf   db   13,10,0
crlf    proc  near
; print  13,10 to printerc
        mov  dx,printerc
        lea  si,pcrlf
        call pzero
        ret
crlf    endp
cseg    ends
        end
