cseg segment para public 'CODE'
        assume cs:cseg,ds:cseg,es:cseg
public  printint,epsone1,epsone2
extrn printswap:byte,print1:word,print2:word,int17:dword
extrn epson1:near,epson2:near,semaphore:byte
epsone1   db  0
epsone2   db  0
saveax   dw 0
p_semaphore db 0
counter   dw 0
p_int   proc near
;
; printer interrupt
;
printint:
; return signature if its a 99 code
        cmp ah,99
        jne gogop
        mov ax,0f9f9h
        push cs
        pop  es  ; good for changing fonts
        iret
gogop:
; here we consider whether or not to process in epson mode
;
;    dx has the printer number
;    ah has the print function we want only ah=0
contprint1:
        push ax
        mov  al,1
lock    xchg cs:p_semaphore,al
        test al,al
        jz  contprint
        pop  ax
goback:
        iret
no_proc:
        pushf
        call cs:[int17]
        mov  cs:p_semaphore,0
        iret
retstack:
        mov  cs:p_semaphore,0
        jmp  goback
contprint:
        pop  ax
        cmp  ah,2
        jg   no_proc
        cmp  dl,1
        jg   no_proc
        cmp ah,0
        jne  noepson
        cmp dl,0
        jne noepson
; we are at lpt2: is it in epson emulation mode ?
       cmp cs:epsone1,0
       je  noepson
        mov  cs:p_semaphore,0
        call epson1
        jmp  retstack
noepson:
 ; we enter here due to printer interrupt being trigered and
 ; redirected to here
 ; check to see if it is for us
        mov  cs:saveax,ax
        push  dx
        sti
        cmp   cs:printswap,1
        jne  pcont0a
        cmp  dl,1
        jne  pcont0b
        mov  dl,0
        jmp  pcont0a
pcont0b:
        cmp  dl,0
        jne  pcont0a
        mov  dl,1
pcont0a:
        cmp  dl,0
        jne  pcont1
        cmp  cs:[print1],0fffh
        jne  pcont2
        jmp  pgoback
pcont1:
        cmp  dl,1
        jne  pgoback
        cmp  cs:[print2],0fffh
        jne  pcont2
pgoback:
        pushf
        call cs:[int17]
        pop dx
        jmp  retstack
pcont2:
; we are now in redirect mode
; ah has the function which must be translated
        mov   dh,0
        cmp   dl,0
        je    pint0
        mov   dx,cs:[print2]
        jmp   pintgo
pint0:
        mov   dx,cs:[print1]
pintgo:
; ah has the printer function which must be translated to whatever
        mov   ax,cs:saveax
        cmp   ah,0
        je    char14
        cmp   ah,1
        je    init14
        cmp   ah,2
        je    stat14
        pop   dx
        jmp  retstack
init14:
;       mov   ah,0
;       mov   al,11100011b
;       int   14h
        mov   ax,cs:saveax
        mov   ah,80h
        pop   dx
        jmp  retstack
char14:
        push  cx
        mov   cx,16
char14l:
        mov   ax,cs:saveax
        mov   ah,1
        int   14h
        test ah,80h
        jz    g14a
        loop  char14l
        pop   cx
        mov   ah,19h
        pop   dx
        jmp  retstack
stat14:
        mov   ah,3
        int   14h
; now we must translate the results of the action into printer terms
        and   ah,60h
        cmp   ah,60h
        jz  g14
        mov   ax,cs:saveax
        mov   ah,10h
        pop   dx
        jmp  retstack
g14a:
        pop  cx
g14:
        mov  ax,cs:saveax
        mov  ah,90h
        pop   dx
        jmp  retstack
p_int   endp
cseg    ends
        end
