
#include        <stdio.h>
#include	<stdlib.h>
#include        <memory.h>
#include        <malloc.h>
#include        "dbf.h"

main(int argc,char **argv)
{
    int errornum;
    long rec;
    int fld;
    struct DBF *d;
    static char buff[255];

    if(argc != 2)
    {
	printf("Usage: LISTDB filename\n");
	exit(1);
    }

    d = (struct DBF *)malloc(sizeof(struct DBF)); /* allocate space for DBF */

    strcpy(d->filename,argv[1]);

    if(!strchr(d->filename,'.')) 	/* default to .dbf file */
	strcat(d->filename,".DBF");


    if((errornum = d_open(d)) != 0) 	/* open file */
    {
	printf("Error opening file: ");
	switch (errornum)
	{
	case OUT_OF_MEM:
	    printf("Not enough memory.\n");
	    break;
	case NO_FILE:
	    printf("Can not open file %s.\n",d->filename);
	    break;
	case BAD_FORMAT:
	    printf("File %s is not a dBASE III file.\n",d->filename);
	    break;
	}
	free(d);
	exit(1);
    }
 /* test the d_getfnum guy */
    rec=1;
    rec=d_locate(d,"date","03/04/93");
    while(rec>0)
    {
    printf("\nTest of d_locate DATE=03/04/93 = %ld\n",rec);
    rec=d_continue(d,"date","03/04/93",rec+1);

    }
    d_close(d);
    free(d);
}

