cseg segment para public 'CODE'
assume cs:cseg,ds:cseg,es:cseg
extrn  targ_buff_size:word,targ_buff:word,curr_buff:word,curr_buff_size:word
unrle:
public rle,unrle
; rle's targ_buff into curr_buff
     push  dx
     push  ds
     push  es
     mov   es,curr_buff
     mov   ds,targ_buff
     mov  di,0
     mov  si,0
     lodsw
     dec  ax
     dec  ax
     mov  bp,ax
utop:
     lodsb
     mov  ah,0
     dec  bp
     cmp  al,0
     jge  al_low
     neg  al
; there are posiblities here.
; if al > 2 then it is a straight string undo
; if it is 2,1 or zero then there is a word of stuff to check
     cmp  al,1
     jne  no_word
     lodsw
     dec  bp
     dec  bp
no_word:
     mov  cx,ax
     lodsb
     dec  bp
     cld
rep  stosb
     jmp  ubot
al_low:
     mov  ch,0
     mov  cl,al
     sub  bp,cx
     cld
rep  movsb
ubot:
    cmp  bp,0
    jg   utop
    pop   es
    pop   ds
    mov   targ_buff_size,di
    pop   dx
     ret
rle:
; this takes the data in buffer and squeezes it into targ_buff
;
;
; 
     push  dx
     push  ds
     push  es
     mov  bp,curr_buff_size
     mov  si,0
     mov  bx,0
     inc  bx  ; first word is for length of rle buffer
     inc  bx
     mov  ax,0
     mov  di,bx
     mov  cx,0
     mov  es,targ_buff
     mov  ds,curr_buff
     stosb
top:
     lodsb
     cmp  bp,3
     jle  is_diff
     cmp  ds:[si],al
     jne  is_diff
     cmp  ds:[si+1],al
     jne  is_diff
;    cmp  ds:[si+2],al
;    jne  is_diff
; is same
     cmp   cx,0
     je    new_string
; finish the last diff string
     mov  byte ptr es:[bx],cl
     jmp  old_string
new_string:
     mov  di,bx
old_string:
; scan to see how long characters last
     mov  bx,di    ; save di
     mov  di,si    ; set scan start
     mov  cx,bp    ; set scan limit , bp has remaining bytes + 1
     dec  cx       ; bp has not been decremented yet
     cld
     push  es
     push  ds
     pop   es
repe scasb
     pop   es
     jne   cx_nz   ; if last byte is not equal then continue
     inc   di      ; else we have to bump up to get correct count
cx_nz:
     mov  cx,di    ; byte after unequal byte
     sub  cx,si    ; byte after first byte of string, cx has length
; here if cx is between 100h and 2ffh then we use second method
     add  si,cx    ; si now points to first unequal byte
     dec  si
     mov  di,bx    ; restore di
     sub  bp,cx    ; dec bp by amount of string
     cmp  cx,128
     jl   old_method
; cx is 100 to 2ff
     mov  dl,al    ; save al for store
     mov  al,-1    ; -1 indicates that a word length is stored
     stosb
     mov   ax,cx   ; next length
     stosw
     mov   al,dl
     stosb         ; next byte
     jmp   end_string
old_method:
     neg  cx
     mov  ah,al
     mov  al,cl
     stosw
end_string:
     mov  cx,0     ; count
     mov  bx,di    ; count byte
     mov  al,0     ; start at 0
     stosb         ; store it
     jmp  bot
is_diff:
     dec  bp
     stosb
     inc  cx
     cmp  cx,126
     jg   do_string
     jmp  bot
do_string:
     mov  byte ptr es:[bx],cl
     mov  cx,0
     mov  bx,di
     mov  al,0
     stosb
bot:
    cmp   bp,0
    jle   bot1
    jmp   top
bot1:
    cmp   cx,0
    je    bot2
    mov  byte ptr es:[bx],cl
    inc  di
bot2:
    dec   di
    mov   cx,di
    mov   word ptr es:[0],cx  ; places rle length in first word of buffer
     pop   es
     pop   ds
     mov   targ_buff_size,cx
     pop   dx
     ret
cseg  ends
     end
