print macro string
   lea   dx,string
   mov   ah,9
   int   21h
   endm
;
EXE_HEADER STRUC
db 0
signature dw 5a4dh
remainder dw 0
exe_size  dw 0
reloc_count dw 0
header_size dw 0
min_mem     dw 0
max_mem     dw 0
ss_seg      dw 0
sp_reg      dw 0
checksum    dw 0
ip_reg      dw 0
cs_reg      dw 0
relo_loc    dw 0
            db 0  ; overlay number
EXE_HEADER ENDS
;
cseg segment 'CODE'
   assume cs:cseg,ds:cseg,ds:cseg
   org  100h
entry: jmp start
; data
hi  db "working on EXE header",13,10,'$'
step2 db "Relocated to end",13,10,'$'
istack  db  256 dup(0)
head  dw 28 dup(0)
;
; resolution info from exe header
;
psp  dw 0  ; entry psp location
start:
; stategey:
;   0) save the entry situation (especially psp)
;   1) relocate to area after physical file size
;   2) move the exe file down to 100h (decompressing as needed)
;   3) resolve externals
;   4) move down over header
;   5) set stack and data segments
;   6) jmp to cs:ip entry
     mov   cs:psp,ds
     mov   bx,ds
     mov   ax,cs
     mov   ds,ax
     mov   es,ax
     mov   ss,ax
     mov   sp,offset istack+254
     push  bx
     xor   ax,ax
     push  ax
     print hi
;
;  save the header stuff  28 bytes of uncompressed data
;
     mov   si,offset exe_head
     lea   di,head
     cld
     mov   cx,29
rep  movsw
;
; now locate my code at the end of the exe
;
;
     mov   ax,head.exe_size
     mov   dh,0
     mov   dl,ah
     mov   ah,al
     mov   al,0
     shl   ax,1
     rcl   dx,1
     add   ax,head.remainder
     push  ax
     push  dx
     add   ax,511  ; rounding up
     adc   dx,0
     lea   cx,exe_head+0
     sub   cx,100h
     add   ax,cx
     adc   dx,0
;  now find out how many segments to skip over
     mov   cx,16
     div   cx
;  ax has the number of segments to skip. BX has the PSP
     mov   bp,ax       ; save this for later
     add   ax,bx
     sub   ax,10h      ; don't need a psp at end
     mov   di,100h
     mov   es,ax
     mov   si,100h
     mov   cx,offset exe_head-100h
     cld
rep  movsb
     push  es
     lea   dx,continue
     push  dx
     db  0cbh  ;retf
continue:
     mov   dx,cs
     mov   ss,dx
     mov   ds,dx
     print step2
;
; we are at the end of the exe header
; next step is to relo everyone down
;
     mov    bx,cs:psp
     mov    di,100h
     mov    si,offset exe_head+28
     mov    cx,bp  ; physical file size
     dec    cx
     dec    cx
md_top:
     push   cx
     push   si
     push   di
     mov    cx,8
     mov    es,bx
     mov    ds,bx
rep  movsw
     inc    bx
     pop    di
     pop    si
     pop    cx
     loop   md_top
     mov  cx,12
rep  movsb
;
     mov   ax,4cffh
     int 21h
exe_head db 0
cseg ends
     end entry
