print macro string
     lea dx,string
     mov    ah,9
     int    21h
     endm
segmentsize EQU  8000h
;
;
cseg     SEGMENT PARA PUBLIC 'CODE'
PUBLIC   reset_segs,end_prog,exit_prog
     ASSUME CS:cseg,DS:cseg,ES:cseg
        org 100h
entry: jmp start
     db 13,10,'This file created by HDI.COM automated installer.',13,10
     db 'Copyright 1988 by Keith P. Graham',13,10
     db 'If you need more information on creating customized',13,10
     db 'installation procedures, or you are interested in',13,10
     db 'purchasing a copy of HDI, call PC-Rockland BBS at',13,10
     db '(914) 353-2157.',13,10,26
buffer  dw 0
public buffer
psp     dw  0
start_stack dw  0
ret_sp   dw  0
sav_brk  dw  0
breaker  dw  0
lpt     dw  0
err1    db 13,10,'Memory allocation error',13,10,'$'
thanks  db 13,10,'Hard Disk Installation Complete',13,10,'$'
istack   db 512 dup(0) ; internal stack
;
extrn  imain:near,last_byte:near
start    PROC   near
; entry procedure
; shrink
; must shrink down to stack segment which is always last
     lea     sp,istack+510  ; internal stack
     lea     bx,last_byte
     add     bx,15
     shr     bx,1
     shr     bx,1
     shr     bx,1
     add     bx,200h  ; 8 K for other stuff
     MOV     AH,4ah
     INT     21h
     jnc     ok_stack
     lea     dx,err1
     jmp     end_prog
ok_stack:
; set up return
     MOV     psp,ES
;
; allocate memory areas
;
     Jmp    goodget2
memory_error:
     lea     dx,err1
     JMP     end_prog
goodget2:
; allocate the IO buffers - 32k of them (16k for each)
     MOV     AH,48h
     MOV     BX,800h ; 800h*16 = 32k
     INT     21h
     jc     memory_error
     CMP     BX,800h
     JNE     memory_error
     MOV     buffer,AX
; get configuration file
     call   reset_segs
;

; set up BREAK key exit
     CALL   break_on
     call   reset_segs
     call   imain
exit_prog:
     lea dx,thanks
; this is the normal menu exit
end_prog:
; in order to end the program there must be a message in dx
     PUSH   DX     ; this has the ending message
     CALL   reset_segs
     CALL   break_off
     POP     DX
     mov     ah,9
     int     21h
     mov    ah,4ch
     mov    al,0
     int    21h
     RET
start    ENDP
reset_segs     PROC    NEAR
     PUSH   AX
     MOV     AX,cs
     MOV     DS,AX
     MOV     ES,AX
     POP     AX
     RET
reset_segs     ENDP
eoi     EQU     20h     ;END OF INTERRUPT
brkint   EQU     1bh     ;BREAK INTERRUPT
break_on     PROC    NEAR
; this sets the control break, also sets critical error
;
; crit_err first
;
     LEA     DX,CS:break_it
     PUSH   DS
     MOV     AX,CS
     MOV     DS,AX
     MOV     AX,2524h
     INT     21h
     POP     DS
;
     PUSH   ES
     MOV     AX,351bh
     INT     21h
; es:bx returns with the interrupt
     MOV     sav_brk,BX     ;SAVE OFFSET
     MOV     sav_brk+2,ES    ;SAVE SEGMENT
     POP     ES
     LEA     DX,CS:break_it
     PUSH   DS
     MOV     AX,CS
     MOV     DS,AX
     MOV     AX,251bh
     INT     21h
     POP     DS
     RET
break_on     ENDP
break_off     PROC   NEAR
     MOV     DX,sav_brk     ;RESET VECTOR BACK TO OLD RTN
     MOV     AX,sav_brk+2
     PUSH   DS
     MOV     DS,AX
     MOV     AX,251bh
     INT     21h
     POP     DS
     RET
break_off     ENDP
break_it     PROC    NEAR
; break handler
     MOV     AL,eoi
     OUT     020h,AL
     CALL   reset_segs
     MOV     AX,cs
     MOV     SS,AX
     MOV     SP,breaker
     STI
     lea dx,thanks
     jmp     end_prog
break_it     ENDP
cseg     ENDS
     END     entry
