flag = 0d6h
print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
cseg segment 'CODE'
   assume cs:cseg,ds:cseg,es:cseg,ss:cseg
   org   100h
entry:
        jmp   start
hello  db 'hello',13,10
    db 'Copyright 1989 by Keith P. Graham',13,10,'$'
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
error4 db 'Error creating output file.',13,10,'$'
error5 db 'Error Writing File (disk full?)',13,10,'$'
file1     db   65  dup(0)
file_size dw 0
file2     db   65  dup(0)
handlei dw 0
bufferi dw 0
handleo dw 0
buffero dw 0
switch1 db 0
switch2 db 0
nodespace dw 0
lastguy   db 0
free  dw 0
buffsize dw 0
buffloc  dw 0
outsize  dw 0
out_count dw 0,0
nodes struc
first dw ?
side  dw ?
who   dw ?
rank  dw ?
nodes ends
;
;
goodbye db 'Bytes read:    '
rbytes  db '         ',13,10
        db 'Bytes written: '
bwrit   db '         ',13,10
        db 'Codes written: '
cwrit   db '         ',13,10
       db 13,10,'$'

buck1  dw  0,0
buck2  dw  0,0
buck3  dw  0,0
buck4  dw  0,0
;
;
press:
; this compresses data in file, uses follows and rank technique
   call  get_word
   jnc   pr_0
   ret
pr_0:
   mov   bl,lastguy
   mov   bh,0
   shl   bx,1
   shl   bx,1
   shl   bx,1
   mov   di,bx
   mov   si,bx
   mov   dx,1
;
; *** FIRST WORD******
;
   cmp   es:[di].first,-1
   jne   hit_first
   call  put_word
   mov   lastguy,al
   mov   dx,0
   call  add_node
   mov  es:[di].first,si
   jmp   press
hit_first:
; have a hit on first guy follow it
   mov   di,es:[di].first
;
; see if we match now
trace_side1:
   cmp   es:[di].who,ax
   je    check_second
; no hit on first level, check_side
   cmp   es:[di].side,-1
   je    no_side1
   mov   di,es:[di].side
   jmp   trace_side1
no_side1:
; have an ax to write out, and a side to add
   call  put_word
   mov   lastguy,al
   mov   dx,0
   call  add_node
   mov  es:[di].side,si
   jmp   press
;
; ***** SECOND WORD *********
;
check_second:
   mov   si,di
   mov   bp,ax
   call  get_word
   jnc   hs_1
   call  put_word
   ret
hs_1:
   cmp   es:[di].first,-1
   jne   hit_second
; have an ax which must be saved
   push  ax
   mov   ax,bp
   call  put_word
   mov   lastguy,al
   pop   ax
   mov   dx,0
   call  put_word
   mov   lastguy,al
   call  add_node
   mov  es:[di].first,si
; update another node
   cmp  si,-1
   jne  ad2
   jmp press
ad2:
   mov  di,si
   call  get_word
   call  add_node
   mov  es:[di].first,si
   jmp   pr_0
hit_second:
   mov   di,es:[di].first
trace_side2:
   cmp   es:[di].who,ax
   je    hit_f
   cmp   es:[di].side,-1
   je    no_side2
   mov   di,es:[di].side
   jmp   trace_side2
no_side2:
   push  ax
   mov   ax,bp
   call  put_word
   mov   lastguy,al
   pop   ax
   mov   dx,0
   call  add_node
   call  put_word
   mov   lastguy,al
   mov  es:[di].side,si
   cmp  si,-1
   jne  ad3
   jmp press
ad3:
   mov  di,si
   call  get_word
   call  add_node
   mov  es:[di].first,si
   jmp   pr_0
   jmp   press
;
; ***** THIRD WORD *********
;
hit_f:
; got a hit on last node, now get another word
   mov   si,di   ; save last hit of a node
   call  get_word
   jnc   hit_f2
   mov   dx,es:[di].rank  ; put_code outputs dx
   call  put_code
   ret
hit_f2:
   cmp   es:[di].first,-1
   jne   hit_third
; here we have a hit on current node
   mov   cx,es:[di].who
   mov   dx,es:[di].rank
   mov   cx,es:[di].who
   call  put_code
   mov   lastguy,cl
   mov   dx,3
   call  add_node
   mov  es:[di].first,si
   jmp   pr_0
hit_third:
   mov   di,es:[di].first
trace_side3:
   cmp   es:[di].who,ax
   je    hit_f
   cmp   es:[di].side,-1
   je    third_side
   mov   di,es:[di].side
   jmp   trace_side3
third_side:
; no hit on second level, add side
   mov   dx,es:[si].rank
   mov   cx,es:[si].who
   call  put_code
   mov   lastguy,cl
   mov   dx,3
   call  add_node
   mov  es:[di].side,si
   jmp   pr_0
;
add_node:
; this adds a free node to di-first
   mov  si,-1
   mov  cx,es:[bx].rank
   cmp  cx,1022
   ja   af_3
;  cmp  cx,flag
;  jne  af_a
;  inc  cx
af_a:
   mov  si,free
   cmp  si,-1
   jne  af_0
   call init_nodes
   mov  si,free
af_0:
   mov  es:[si].rank,cx
   cmp  dx,2    ; 1=first word, 2 = second 3 = all others
   jl   af_2
   inc  cx
   mov  es:[bx].rank,cx
af_2:
   mov  cx,es:[si].first
   mov  free,cx
   mov  es:[si].first,-1
   mov  es:[si].side,-1
   mov  es:[si].who,ax
af_3:
   ret
;
put_code:
    cld
; puts out a code or a word
    add  buck3,1
    adc  buck3+2,0
    push  di
    mov   di,outsize
    push  es
    mov   es,buffero
    push  ax
    mov   al,flag
    stosb
    mov   al,dl
    stosb
    pop   ax
check_out:
    mov   outsize,di
    cmp   di,4000h
    jb    c0_1
    call  write_file
    mov   outsize,0
c0_1:
    pop   es
    pop   di
    ret
put_word:
    add  buck2,1
    adc  buck2+2,0
    push  di
    mov   di,outsize
    push  es
    mov   es,buffero
    cmp   al,flag
    jne   pw_1
    stosb
;   add  out_count,5
;   adc  out_count+2,0
pw_1:
    stosb
    jmp    check_out
get_word:
    add  buck1,1
    adc  buck1+2,0
    push si
    push ds
    mov  si,buffloc
    cmp  si,buffsize
    jb   got_word
    pop  ds
    call read_file
    jnc  gw_1
    pop  si
    stc
    ret
gw_1:
    push ds
    mov  si,0
got_word:
    mov  ds,bufferi
    cld
    lodsb
    mov  ah,0
    pop  ds
    mov  buffloc,si
    clc
    pop  si
    ret
init_nodes:
    push  es
    push  di
    push  cx
    push  ax
    mov   es,nodespace
    mov   di,0
    mov   cx,256
in_0:
    mov   es:[di].side,-1
    mov   es:[di].first,-1
    mov   es:[di].rank,0
    add   di,8
    loop  in_0
    mov   cx,6000
    mov   free,di
    mov   ax,di
in_1:
    add   ax,8
    mov   es:[di].first,ax
    mov   di,ax
    loop  in_1
    mov   es:[di].first,-1
    pop   ax
    pop   cx
    pop   di
    pop   es
    ret
start:
    print hello
    call  parse_line
    jc    error_exit
    call  open_file
    jc    error_exit
    call  create_file
    jc    error_exit
    call  memory_alloc
    jc    error_exit
    call  init_nodes
    call  read_file
    jc    error_exit
    cmp   ax,0
    je    good_exit
    push  es
    mov   es,nodespace
    mov   lastguy,20h
    call  press
    pop   es
    cmp   outsize,0
    je    good_exit
    call  write_file
    jc    error_exit
good_exit:
    call  stats
    lea   dx,goodbye
    cmp   outsize,0
    je    error_exit
    call   write_file
error_exit:
    mov   ax,cs
    mov   ds,ax
    mov   ah,9
    int   21h
    int   20h

;
stats:
    lea  di,rbytes
    mov  ax,buck1
    mov  dx,buck1+2
    call bin2hex
    lea  di,bwrit
    mov  ax,buck2
    mov  dx,buck2+2
    call bin2hex
    lea  di,cwrit
    mov  ax,buck3
    mov  dx,buck3+2
    call bin2hex
    ret
bin2hex:
    mov   cx,10000
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    mov   dx,0
    mov   cx,100
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    div   cl
    or    ax,3030h
    stosw
    ret
;

;
;
write_file:
; get the file into memory
; cx has the size of file to write
    push  ax
    push  bx
    push  cx
    push  dx
    push  ds
    mov   cx,outsize
    mov   outsize,0
    mov   bx,handleo
    mov   dx,0
    mov   ds,buffero
    mov    ah,40h
    int    21h
    pop    ds
    jc     bad_write
    cmp    ax,cx
    je     good_write
bad_write:
    lea dx,error5
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    stc
    ret
good_write:
    pop   dx
    pop   cx
    pop   bx
    pop   ax
    clc
    ret
;
;
create_file:
    mov  ax,3c00h
    mov  cx,0
    lea  dx,file2
    int  21h
    jnc  good_create
    lea  dx,error4
    stc
    ret
good_create:
    mov  handleo,ax
    clc
    ret
;
read_file:
; get the file into memory
    push  ds
    mov   bx,handlei
    mov   dx,0
    mov   cx,07000h
    mov   ds,bufferi
    mov    ah,3fh
    int    21h
    pop    ds
    jnc    good_read
bad_read:
    lea dx,error3
    stc
    ret
good_read:
    mov   buffsize,ax
    mov   buffloc,0
    cmp   ax,0
    je    bad_read
    clc
    ret
open_file:
; opens the file for reading
    mov  ax,3d10h
    lea  dx,file1
    int  21h
    jnc  good_open
    lea  dx,error1
    stc
    ret
good_open:
    mov  handlei,ax
    clc
    ret
;
last_byte equ this word
parse_line:
; strategy is you have to scan for switches
; then you look for an infile and an outfile
;
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
    mov  bx,0
    cld
pl0:
    mov  al,'/'
repne scasb
    jne  pl2
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    or   al,32
    mov  switch1[bx],al
    inc  bx
    cmp  cx,0
    jle  pl2
    jmp  pl0
pl2:
    mov  si,81h
    lea  di,file1
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    cmp  cx,3
    jge  ok_fname
bad_fname:
    lea dx,error1
    stc
    ret
ok_fname:
; set up file
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   ok_fname
    cmp  al,9
    je   ok_fname
parse1:
    stosb
    lodsb
    cmp  al,13
    je   parse2
    cmp  al,20h
    je   parse2
    cmp  al,9
    jne  parse1
parse2:
    mov  ax,0
    stosw
    lea  di,file2
parse3:
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   parse3
    cmp  al,9
    je   parse3
parse4:
    stosb
    lodsb
    cmp  al,13
    je   parse5
    cmp  al,20h
    je   parse5
    cmp  al,9
    jne  parse4
parse5:
    mov  ax,0
    stosw
    clc
    ret
;
memory_alloc:
; allocates memory
; shrink
;
    mov  cx,0
    lea  ax,last_byte+512
    add  ax,15
    shr  ax,1
    shr  ax,1
    shr  ax,1
    shr  ax,1
    mov  bx,ds
    add  bx,ax
    mov  ax,4a00h
    int  21h
    jnc  good_shrink
bad_mem:
    lea dx,error2
    stc
    ret
good_shrink:
; allocate stack
    mov  ah,48h
    mov  bx,100h ; 256*16 = 4096
    int  21h
    jc   bad_mem
    pop  bx
    mov  ss,ax
    mov  sp,4094
    push bx
    mov  ah,48h
    mov  bx,1000h
    int  21h
    jc   bad_mem
    mov  nodespace,ax
; allocate 64k buffer for file access
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:bufferi,ax
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  es:buffero,ax
    clc
    ret
cseg ends
    end entry
