cseg    segment
wprot   proc  far
assume  cs:cseg,ds:cseg,es:cseg,ss:cseg
        org  100h
start:  jmp go
handle  dw 0
fcount  dw 0
lcount  db 6
totcount dw 0
version db 0
update  db 0,0,0
reccount dd 0
header   dw 0
recl     dw 0
         db  20 dup(0)
field    db  11 dup(0)
itype    db  0
         dd  0
flength  db  0
fdec     db  0
         db  14 dup(0)
emess1  db 'The format of the DISPSTRU command is:',13,10
        db '  DISPSTRU disk:path\dbfname',13,10
        db 'where:',13,10
        db 'disk is a valid disk drive',13,10
        db 'path\ is a valid path to the database file',13,10
        db 'dbfname is the name of the database without the',13,10
        db '.dbf extension',13,10,10
      db 'Comments should be addressed to:',13,10
      db 'Keith P. Graham',13,10
      db 'Graham Systems',13,10
      db '238 Germonds Rd.',13,10
      db 'W. Nyack, NY 10994',13,10
      db 'Or PC-Rockland BBS at (914) 353-2176',13,10
         db 13,10,'$'
emess2  db 13,10,'error opening file',13,10,10,'$'
emess3  db 13,10,'error reading file',13,10,10,'$'
emess4  db 13,10,'invalid file header',13,10,10,'$'
cmess   db 'Strike any key to continue......$'
crlf    db  13,10,'$'
spacer  db  13,40 dup(20h),13,'$'
switch  db 0
ten     db 10
thousand dw 1000
line1    db 'Graham Systems DISPSTRU, copyright 1985,1987 by '
         db 'Keith P. Graham',13,10,10
         db 'Structure for database : '
parsename db 55 dup(0)
line2    db 'Number of data records : '
dig7     db 30h
dig6     db 30h
dig5     db 30h
dig4     db 30h
dig3     db 30h
dig2     db 30h
dig1     db 30h
         db 13,10,'$'
line3    db 'Date of last update    : '
mm2      db 0
mm1      db 0
         db '/'
dd2      db 0
dd1      db 0
         db '/'
yy2      db 0
yy1      db 0
         db 13,10,'$'
heading  db 'Field  Field name  Type       Width     Dec',13,10,'$'
pnum     db  5 dup(0)
         db  '  '
pname    db 11 dup(0)
         db 0
ptype    db 10 dup(0)
         db 0
pwidth   db 5 dup(0)
         db '   '
pdec     db 9 dup(0)
         db 13,10,'$'
lastline db '** Total **                '
lastcnt  db '          '
         db 13,10,10,'$'
char     db 'Character '
num      db 'Numeric   '
log      db 'Logical   '
Memo     db 'Memo      '
Date     db 'Date      '
go:
 ; first check out the commadn line and see if we can open the
; inout file
        mov al,ds:80h
        cmp al,2
        jl err1
        jmp noerr
err1:
        lea dx,emess1
        mov ah,9
        int 21h
        jmp int20
noerr:
; bx has the parse level
; I hate parses but here we go
        mov bx,0
        mov ah,0
        mov cx,ax   ; cx has the parse count
        mov si,81h
        lea di,parsename
spaceloop:
        lodsb
        cmp al,0dh
        je  err1
        cmp al,0ah
        je  err1
        cmp al,'/'
        je  switch1
        cmp al,20h
        jne  fileloop
        loop spaceloop
        jmp  err1
switch1:
; got a switch
        lodsb
        dec cx
        mov switch,al
        loop spaceloop
; have the first character of filename in al
fileloop:
        cmp al,'.'
        je  extension
        cmp al,'/'
        je  switch2
        cmp al,0dh
        je  err1
        cmp al,0ah
        je  err1
        cmp al,20h
        je  extension
        stosb
        lodsb
        loop fileloop
        jmp  extension
switch2:
; got a switch
        lodsb
        dec cx
        mov switch,al
        loop fileloop
extension:
        mov  ax,'d.'
        stosw
        mov  ax,'fb'
        stosw
        inc  di
        mov  ax,0a0dh
        stosw
        mov  al,'$'
        stosb
; check and see if there was a switch
        cmp switch,0
        jne openit
; here  check the whole line fo a switch
        mov cl,byte ptr ds:80h
        mov di,80h
        mov al,'/'
repne   scasb
        jne openit
        mov al,byte ptr ds:[di]
        mov switch,al
openit:
; have the file, now I need to open it for input
        lea  dx,parsename
        mov  ah,3dh
        mov  al,0
        int  21h
        jnc  okopen
 ; bad open on file
        lea  dx,emess2
        mov  ah,9
        int  21h
        jmp  err1
okopen:
     ; got a handel in ax
        mov  handle,ax
     ; get first part of header
        lea  dx,version
        mov  cx,32
        mov  bx,handle
        mov  ah,3fh
        int  21h
        cmp  ax,cx
        je   goodread1
 ; bad read on file
        lea  dx,emess3
        mov  ah,9
        int  21h
        jmp  err1
goodread1:
        cmp  version,83h
        je   goodread2
        cmp  version,03h
        je   goodread2
        lea  dx,emess4
        mov  ah,9
        int  21h
        jmp  err1
goodread2:
;
;  display dbase header information
;
;    first line 1 is ready so go with it
          lea  dx,line1
          mov  ah,9
          int  21h
; now try to do the filesize
          mov  ax,word ptr reccount
          mov  dx,word ptr reccount+2
          div  thousand
; dx has remainder, ax has quotient
          cmp  ax,0
          je   remainder
; must work on ax for now, has 1,000 + in it
          div  ten
;   ah how has dig4 in it
          add  ah,30h
          mov  dig4,ah
          cmp  al,0
          je remainder
          mov ah,0
          div  ten
          add  ah,30h
          mov  dig5,ah
          cmp  al,0
          je   remainder
          mov ah,0
          div  ten
          add  ah,30h
          mov  dig6,ah
          cmp  al,0
          je   remainder
          mov ah,0
          div  ten
          add  ah,30h
          mov  dig7,ah
remainder:
          mov  ax,dx
          div  ten
          add  ah,30h
          mov  dig1,ah
          mov ah,0
          div  ten
          add  ah,30h
          mov  dig2,ah
          mov ah,0
          div  ten
          add  ah,30h
          mov  dig3,ah
; check for leading zeroes
          cld
          mov  cx,6
          lea  si,dig7
          mov  di,si
zloop:
          lodsb
          cmp  al,30h
          jne  zloope
          mov  al,20h
          stosb
          loop zloop
zloope:
          lea  dx,line2
          mov  ah,9
          int  21h
;lets do date next - its easy
          mov  al,update
          mov ah,0
          div  ten
          add  ax,3030h
          mov  yy1,ah
          mov  yy2,al
          mov  al,update+1
          mov ah,0
          div  ten
          add  ax,3030h
          mov  mm1,ah
          mov  mm2,al
          mov  al,update+2
          mov ah,0
          div  ten
          add  ax,3030h
          mov  dd1,ah
          mov  dd2,al
          lea  dx,line3
          mov  ah,9
          int  21h
; now print out the fields
          lea  dx,heading
          mov  ah,9
          int  21h
          mov  ax,header
          sub  ax,33
          mov  cl,5
          shr  ax,cl
; ax has number of fields to read
          mov  cx,ax
ploop:
          push cx
          jmp  pbegin
ploopt:
          pop  cx
          loop ploop
; now done have to convert totcount to decimal
          mov  ax,totcount
          inc  ax
          mov  dx,0
          div  thousand
          cmp  ax,0
          je   totdx
          div  ten
          add  ah,30h
          mov  lastcnt+4,ah
          cmp  al,0
          je   totdx
          mov ah,0
          div  ten
          add  ah,30h
          mov  lastcnt+3,ah
          cmp  al,0
          je   totdx
          mov ah,0
          div  ten
          add  ah,30h
          mov  lastcnt+2,ah
totdx:
          mov  ax,dx
          div  ten
          add  ah,30h
          mov  lastcnt+7,ah
          cmp  al,0
          je   totdxd
          mov ah,0
          div  ten
          add  ah,30h
          mov  lastcnt+6,ah
          cmp  al,0
          je   totdxd
          mov ah,0
          div  ten
          add  ah,30h
          mov  lastcnt+5,ah
totdxd:
          lea  dx,lastline
          mov  ah,9
          int  21h
; close the file
        lea  bx,handle
        mov  ah,3eh
        int  21h
          jmp  int20
pbegin:
;read 32 bytes into record area
        lea  dx,field
        mov  cx,32
        mov  bx,handle
        mov  ah,3fh
        int  21h
        cmp  ax,cx
        je   goodread3
 ; bad read on file
        lea  dx,emess3
        mov  ah,9
        int  21h
        jmp  err1
goodread3:
; now we have the filed descriptor
;
; clear out line (44 bytes)?
        mov  cx,44
        lea  di,pnum
        mov  al,20h
repnz   stosb
        add fcount,1
        mov ax,fcount
        div ten
        add ah,30h
        mov pnum+4,ah
        cmp al,0
        je  pnumdone
        mov ah,0
        div ten
        add ah,30h
        mov pnum+3,ah
        cmp al,0
        je  pnumdone
        mov ah,0
        div ten
        add ah,30h
        mov pnum+2,ah
        cmp al,0
        je  pnumdone
        mov ah,0
        div ten
        add ah,30h
        mov pnum+1,ah
        cmp al,0
        je  pnumdone
        mov ah,0
        div ten
        add ah,30h
        mov pnum,ah
pnumdone:
; got the field done
;       mov fieldname to formatted fieldname
        lea  di,pname
        lea  si,field
        mov  cx,11
repnz   movsb
; move the type
        mov  al,itype
        lea  si,char
        cmp  al,'C'
        je   moveit
        lea  si,num
        cmp  al,'N'
        je   moveit
        lea  si,log
        cmp  al,'L'
        je   moveit
        lea  si,memo
        cmp  al,'M'
        je   moveit
        lea  si,date
        cmp  al,'D'
        je   moveit
moveit:
        lea  di,ptype
        mov  cx,10
repnz   movsb
; now we have to cope with the width (1 to 255)
        mov  al,flength
        mov ah,0
        cmp  al,0
        je   dodec
        div  ten
        add  ah,30h
        mov  pwidth+4,ah
        cmp  al,0
        je   dodec
        mov ah,0
        div  ten
        add  ah,30h
        mov  pwidth+3,ah
        cmp  al,0
        je   dodec
        mov ah,0
        div  ten
        add  ah,30h
        mov  pwidth+2,ah
dodec:
; now decimal
        cmp  itype,'N'
        jne  ploope
        mov  al,fdec
        cmp  al,0
        je   ploope
        mov ah,0
        div  ten
        add  ah,30h
        mov  pdec+4,ah
        cmp  al,0
        je   ploope
        mov ah,0
        div  ten
        add  ah,30h
        mov  pdec+3,ah
        cmp  al,0
        je   ploope
        mov ah,0
        div  ten
        add  ah,30h
        mov  pdec+2,ah
        cmp  al,0
        je   ploope
        mov ah,0
        div  ten
        add  ah,30h
        mov  pdec+1,ah
ploope:
          mov  al,flength
          mov ah,0
          add  totcount,ax
          lea  dx,pnum
          mov  ah,9
          int  21h
          add  lcount,1
          cmp  lcount,24
          jl   nopause
          cmp  switch,'P'
          je   pause
          cmp  switch,'p'
          je   pause
          jmp  nopause
pause:
          lea  dx,cmess
          mov  ah,9
          int  21h
          mov  ah,7
          int  21h
          lea  dx,spacer
          mov  ah,9
          int  21h
          mov  lcount,0
nopause:
          jmp  ploopt
int20:
        int   20h
wprot   endp
cseg    ends
end     start
