print macro string
   lea  dx,string
   mov  ah,9
   int  21h
   endm
printb  macro string
   lea  si,string
   call printit
   endm
cseg segment
assume cs:cseg,ds:cseg
   org  100h
entry:
    jmp   start
;
hi  db 13,10,"Charlie's disk scanner",13,10,10
    db 'Enter disk 0-1',0
crlf db 13,10,'0'
press db 13,10,'Press any key to start scan',13,10,0
check db 13,10,'Checking sector-track-head:',13,10
sh    db 13
sector db '0000-'
track  db '00-'
head   db '00',13
done   db 13,10,10,10,'Done',13,10,0
disk   db  0
bootr  db  512 dup(0)
ccyl   db  0
csect  db  0
chead  db  0
;
start:
;
printb  hi
s1:
    mov   ah,0
    int   16h
    cmp   al,'0'
    je    s2
    cmp   al,'1'
    jne   s1
s2:
    sub   al,30h
    add   al,80h
    mov   disk,al
printb  crlf
printb  press
; get the boot record
    lea   bx,bootr
    call  read_sector
;
    int   20h
read_sector:
    mov   ah,02
    mov   al,1
    mov   dl,disk
    mov   ch,ccyl
    mov   cl,csect
    mov   dh,dhead
    int   13h
    ret
printit:
     lodsb
     cmp   al,0
     je    pi1
     mov   ah,14
     int   10h
     jmp   printit
pi1:
     ret
cseg   ends
    end entry
