cSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG ;ALREADY SET BY DOS LOADER
        ORG        100H                        ;SKIP TO END OF THE PSP
ENTPT:        JMP        setres                       ;COM FILE ENTRY ALWAYS AT 100H
; data areas
   db 4000h dup(0)
setres:
; move the data area down
        mov   ax,0c800h
        push  ds
        mov   ds,ax
        cmp   word ptr ds:[0],0aa55h
        je    good_b
bad_b:
        pop   ds
        jmp   bad_end
good_b:
        mov   ch,byte ptr ds:[2]
        mov   cl,0
        shl   cx,1
        cmp   cx,0
        jl    bad_b
        cmp   cx,4000h
        jg    bad_b
        mov   si,0
        mov   di,100h
        mov   cx,4000h
        cld
rep     movsb
        pop   ds
;
; install interrupt 40h
        push  es
        mov   cx,256   ; all interrupts
        mov   di,2
        mov   dx,cs
        add   dx,10h
        mov   ax,0
        mov   es,ax
iloop:
        cmp   word ptr es:[di],0c800h
        jne   not_i
        cli
;       mov   word ptr es:[di],dx
        sti
not_i:
        add   di,4
        loop  iloop
;
; fixup DOS
;
        mov   ax,70h
        mov   es,ax
;       mov   word ptr es:[0b2h],dx
        mov   word ptr es:[0b6h],dx
        pop   es
        lea   dx,mess1
        mov   ah,9
        int   21h
        lea   dx,setres
        int 27h
bad_end:
        lea   dx,mess2
        mov   ah,9
        int   21h
        int   20h
mess1   db 'resident',13,10,'$'
mess2   db 'not installed',13,10,'$'
CSEG        ENDS
        END        ENTPT
