print macro string
       lea  dx,string
       mov  ah,9
       int  21h
       endm
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org      100h     ;end of program segment prefix
entry:    jmp      main     ;skip over data
htab    db 1eh,30h,2eh,20h,12h,21h,22h,23h,17h,24h,25h,26h,32h,31h
        db 18h,19h,10h,13h,1fh,14h,16h,2fh,11h,2dh,15h,2ch
file    db 80 dup(0)
filesize dw  0
handle   dw  0
searchstr db 'Alt-Left Shift-'
searcher db  0
searchstrc db 'ALT-LEFT SHIFT-'
searcherc db  0
codestr2 db 0b4h,1,0cdh,16h,80h,0fch   ; eight bytes
codestr  db 'hift2:'                   ; alternative
coder    db  0
emess1  db 'Form of HOTFIX is:',13,10
        db 'HOTFIX filename n',13,10,'$'
emess2  db "Can't open input file, Job aborted",13,10,'$'
emess3  db "Can't read file, Job aborted",13,10,'$'
emess4  db "Can't find trigger string, Job aborted",13,10,'$'
emess5  db "Can't find trigger code, Job aborted",13,10,'$'
emess6  db 'Error writing out file',13,10,'$'
mess2   db 'File altered, job complete',13,10,'$'
main      proc     near
; parse the name
          mov  cl,byte ptr ds:[80h]
          mov  ch,0
          cmp  cl,3
          jg   good_count
bad_parse:
          print emess1
          int   20h
good_count:
;     get file in
; first past leading blanks
          mov   di,81h
          mov   al,' '
           cld
repe      scasb
          je    bad_parse
          dec   di
          inc   cx
          mov   si,di
; search for next space
repne     scasb
          jne   bad_parse
          push  cx
          push  di
          mov   cx,di
          sub   cx,si
          dec   cx
          lea   di,file
rep       movsb
          mov   al,0
          stosb
          pop   di
          pop   cx
          mov   al,' '
repe      scasb
          je    bad_parse
          mov   si,di
          dec   si
          lodsb
          cmp   al,13
          je    bad_parse
          cmp   al,'A'
          jl    bad_parse
          cmp   al,'z'
          jg    bad_parse
          cmp   al,'a'
          jl    ok_upper
          sub   al,32
ok_upper:
          cmp   al,'Z'
          jg    bad_parse
          mov   searcher,al
; now open the file as i/o
          mov   ah,3dh
          mov   al,2
          lea   dx,file
          int   21h
          jnc   good_open
          print emess2
          int   20h
good_open:
          mov   handle,ax
; read file into the area at the end of this program
          mov   bx,ax
          lea   dx,buffer
          mov   ah,3fh
          mov   cx,60000  ; big com file
          int   21h
          jnc   ok_read
          print  emess3
          int   20h
ok_read:
          mov    filesize,ax
; now a global change for the hot key string
          lea    di,buffer
          mov    cx,filesize
          lea    si,searchstr
          mov    bx,0
          cld
          lodsb
rloop0:
repne     scasb
          je     got_a_hit
          cmp    bx,0
          jne    check_trigger
          jmp    check_t_upper
got_a_hit:
          push   cx
          push   si
          push   di
          mov    cx,14
repe      cmpsb
          jne    false_alarm
          mov    dl,byte ptr ds:[di]
          movsb
          inc    bx
false_alarm:
          pop    di
          pop    si
          pop    cx
          jmp    rloop0
check_t_upper:
          lea    di,buffer
          mov    cx,filesize
          lea    si,searchstrc
          mov    al,searcher
          mov    searcherc,al
          mov    bx,0
          cld
          lodsb
rloop2:
repne     scasb
          je     got_a_hit2
          cmp    bx,0
          jne    check_trigger
          print  emess4
          int    20h
got_a_hit2:
          push   cx
          push   si
          push   di
          mov    cx,14
repe      cmpsb
          jne    false_alarm2
          mov    dl,byte ptr ds:[di]
          movsb
          inc    bx
false_alarm2:
          pop    di
          pop    si
          pop    cx
          jmp    rloop2
check_trigger:
; have found the string and changed it
; now find the trigger code sequence
; dl has the current trigger code in it
          mov   bl,dl
          mov   bh,0
          sub   bx,41h
          mov   al,byte ptr htab[bx]
          mov   coder,al
; set upt search for codestr
          lea    si,codestr
          mov    bp,0      ; search count
search_it:
; pass here twice, once for codestr and another for codestr2
          lea    di,buffer
          mov    cx,filesize
          cld
          lodsb
rloop1:
repne     scasb
          je     got_a_hit1
          cmp    bp,0
          jne    no_find_it
          mov    bp,1
          lea    si,codestr2
          jmp    search_it
no_find_it:
          print  emess5
          int    20h
got_a_hit1:
          push   cx
          push   si
          push   di
          mov    cx,5
repe      cmpsb
          jne    false_alarm1
; found our guy have to hange the hot key sequence
;         dec   di
          mov   bl,searcher
          sub   bl,41h
          mov   al,byte ptr htab[bx]
          stosb
          pop    di
          pop    si
          pop    cx
          jmp    write_file
false_alarm1:
          pop    di
          pop    si
          pop    cx
          jmp    rloop1
write_file:
; this repositions the file at beginning and writes it out
          mov     cx,0
          mov     dx,0
          mov     al,0
          mov     ah,42h
          mov     bx,handle
          int     21h
          lea     dx,buffer
          mov     bx,handle
          mov     cx,filesize
          mov     ah,40h
          int     21h
          jnc     good_write
          print   emess6
          int     20h
good_write:
          print   mess2
          mov     bx,handle
          mov     ah,3eh
          int     21h
          int      20h      ; back to dos
main      endp
buffer    equ  this byte  ; end of program
cseg      ends
          end      entry
