putwind2  proc  near
         call  cleandone
          mov  boxx1,39
          mov  boxy1,12
; do top row
         mov   boxd,0
         mov   cx,79
pwloop1:
         call  liner
         inc   boxx2
         loop  pwloop1
         mov   cx,24
pwloop2:
         call  liner
         inc   boxy2
         loop  pwloop2
         mov   cx,79
pwloop3:
         call  liner
         dec   boxx2
         loop  pwloop3
         mov   cx,24
pwloop4:
         call  liner
         dec   boxy2
         loop  pwloop4
         ret
putwind2  endp
liner    proc  near
; this routine draws a line by recursively connecting dots
         push  cx
         mov   cl,boxx1
         mov   ch,boxy1
         mov   dl,boxx2
         mov   dh,boxy2
         push  dx
         push  cx
         mov   dx,cx
         call  putloc
         pop   cx
         pop   dx
; dx has one end and cx has the other
         push  dx
         call  linerec
         pop   dx
         pop   cx
         ret
liner    endp
slope    dw  0
linerec  proc  near
; this is the recursive function
         cmp   cx,boxd
         jne   lr01
         ret
lr01:
         cmp   dx,boxc
         jne   lr02
         ret
lr02:
         cmp   cx,dx
         jne   lr03
         ret
lr03:
         push  dx
         push  cx
; check to see if they are one appart
         sub   cl,dl
         sub   ch,dh
         cmp   cl,0
         je    recend1
         cmp   cl,1
         je    recend1
         cmp   cl,-1
         je    recend1
         jmp   reccont
recend1:
         cmp   ch,0
         je    recend
         cmp   ch,1
         je    recend
         cmp   ch,-1
         je    recend
         jmp   reccont
recend:
         pop   cx
         pop   dx
         call  lineb
         ret
reccont:
         pop   cx
         pop   dx
         push  dx
         push  cx
; this is the recursive part
; divide by 2 and do the cx side
         mov   ax,cx
         add   al,dl
         shr   al,1
         add   ah,dh
         shr   ah,1
         mov   dx,ax
         call  linerec
         pop   cx
         pop   dx
         push  dx
         push  cx
; divide by 2 and do the dx side
         mov   ax,dx
         add   al,cl
         inc   al
         shr   al,1
         add   ah,ch
         inc   ah
         shr   ah,1
         mov   cx,ax
         call  linerec
         pop   cx
         pop   dx
         ret
linerec  endp
lineb    proc  near
         push  dx
         push  cx
         call  putloc
         mov   dx,cx
         call  putloc
         pop   cx
         pop   dx
         ret
lineb    endp
boxx      dw  0
boxy      dw  0
putwind   proc  near
         call  cleandone
; start at the center
          mov  boxx,0
          mov  boxy,1
          mov  dl,39
          mov  dh,12
;  first loop to the right
topput:
; now loop down
           mov  cx,boxy
downbox:
          call  putloc
          add   dl,1
          call  putloc
          add   dl,1
          call  putloc
          sub   dl,2
          add   dh,1
          loop  downbox
; now loop left
          add   boxx,3
          mov   cx,boxx
          add   dl,3
leftbox:
          sub   dl,1
          call  putloc
          loop  leftbox
; now loop up
          add   dh,1
          sub   dl,3
          inc   boxy
          mov   cx,boxy
upbox:
          sub   dh,1
          call  putloc
          add   dl,1
          call  putloc
          add   dl,1
          call  putloc
          sub   dl,2
          loop  upbox
          sub   dh,1
          sub   dl,1
          add   boxx,3
          mov   cx,boxx
rightbox:
          add   dl,1
          call  putloc
          loop rightbox
          add   dl,1
          inc   boxy
          cmp   boxx,79
          jg    endput
          jmp   topput
endput:
          ret
putwind   endp
putloc    proc  near
; dx has the cursor location
; dh has the row, dl the column
          cmp  dl,0
          jge  goodl2
          mov  boxx,80
          ret
goodl2:
          cmp  dl,79
          jle  goodl
          mov  boxx,80
          ret
goodl:
          cmp  dh,0
          jge  goodh2
          ret
goodh2:
          cmp  dh,24
          jle  goodh
          ret
goodh:
          push cx
          push dx
          mov  al,dh
          mov  ah,0
          mov  cx,80
          mul  cl
          mov  dh,0
          add  ax,dx
          shl  ax,1
          mov  bx,ax
          mov  si,windsi
          add  si,bx
; locate the cursor
          shr  bx,1
          cmp  done[bx],1
          jne  oktoput
          pop  dx
          pop  cx
          ret
oktoput:
          mov  done[bx],1
          pop  dx
          push  dx
          mov  ah,2
          mov  bh,bhpage
          int  10h
; put word at cursor
          lodsw
      ;   ah has the  attribute, al, has the character
          mov  bl,ah
          mov  ah,9
          mov  bh,bhpage
          mov  cx,1
          int  10h
          pop  dx
          pop  cx
          ret
putloc    endp
