print macro string
      lea  dx,string
      mov  ah,9
      int  21h
      endm
help1   db 13,10,'press Alt-F10 to exit',13,10
        db       'press Alt-F1 for help',13,10,'$'
;include c:fd.asm
commx 	PROC	NEAR
        print help1
comloop:
        clc
        mov     ah,1
        int     16h
        jz      nochar
        mov     ah,0
        int     16h
        cmp     ax,7100h
        je      exit_ct
        cmp     ax,6800h
        jne     no_help
        call    help
no_help:
        cmp     al,0
        jne     not_special
        push    ax
        call    put_com
        pop     ax
        mov     al,ah
not_special:
        call    put_com
nochar:
        call    get_buffer ; gets a character from the input buffer
        jnc     putchar
        jmp     comloop
putchar:
; check and see if it is as special character
        mov     ah,0
        cmp     ax,0fch
        jg      not_emulated
        cmp     ax,0f2h
        jl      not_emulated
; have an ascii f2 to fa in al
        and     al,0fh
        sub     al,2
        shl     ax,1
        mov     bx,ax
        call    ds:emulate[bx]
        jmp     nochar
not_emulated:
        mov     dx,1
        mov     ah,14
        int     10h
        jmp     nochar
exit_ct:
        call    decom
	ret
emulate dw e102,e103,e104,e105,e106,e107,e108,e109,e10a
        dw e10b,e10c
e102:
; set cursor position dx,bh
        call  get_com
        mov   dl,al
        call  get_com
        mov   dh,al
;       call  get_com
;       mov   bh,al
        mov   bh,0
        mov   ah,2
        int   10h
        ret
e103: ; read pos
e104: ; light pen
e105: ; active page
e108: ;read attribute
        ret
e106:
; set scroll up
        call  get_com  ;al
        mov   ah,6
        push  ax
        jmp   rest_scroll
e107:
; set scroll down
        call  get_com
        mov   ah,7
        push  ax
rest_scroll:
        call  get_com
        mov   bh,al
        call  get_com
        mov   cl,al
        call  get_com
        mov   ch,al
        call  get_com
        mov   dl,al
        call  get_com
        mov   dh,al
        pop   ax
        int   10h
        ret
e109:
; write attribute and character
        call  get_com
        mov   ah,9
        push  ax
        call  get_com
        mov   bl,al
;       call  get_com
;       mov   bh,al
        mov   bh,0
        call  get_com
        mov   cl,al
        call  get_com
        mov   ch,al
        pop   ax
        int   10h
        ret
e10a:
; write character
        call  get_com
        mov   ah,10
        push  ax
;       call  get_com
;       mov   bh,al
        mov   bh,0
        call  get_com
        mov   cl,al
        call  get_com
        mov   ch,al
        pop   ax
        int   10h
        ret
e10b:
        call  get_com
        mov   ah,9
        push  ax
        call  get_com
        mov   bl,al
        mov   bh,0
        pop   ax
        mov   cx,1
        int   10h
        ret
e10c:
        call  get_com
        mov   ah,10
        mov   bh,0
        mov   cx,1
        int   10h
        ret
get_com:
; this waits forever for a com character
       push  bx
       push  cx
       push  dx
       mov  cx,0
getcom1:
       push  cx
       call  get_buffer
       pop   cx
       jnc   exit_gc
       loop  getcom1
exit_gc:
       pop  dx
       pop  cx
       pop  bx
       ret
commx 	ENDP
help   proc near
       print help1
       ret
help  endp
