float struc
fsign	db ?
fexp	dw ?
fhigh	dw ?
flow	dw ?
float	ends
print macro string
	lea	dx,string
	mov	ah,9
	int	21h
	endm
movv  macro x,y
; moves x to y
    push  cx
    lea  si,x
    lea  di,y
    mov  cx,7
    cld
rep movsb
    pop   cx
    endm
normal macro x
local	n1,n2,n3,n4,n5,n6,n7,n8,n9
; normalizes a floater
; a normalized float is one in which the high byte of mantissa is 1
; modify this just so that dh is not negative
	mov	dx,x.fhigh
	mov	ax,x.flow
	mov	cx,x.fexp
	cmp	dx,0
	jne	n1
	cmp	ax,0
	jne	n1
	jmp	short n9
n1:
	cmp	dh,0
	je	n4
	jl	n2
	cmp	dh,64
	jl	n8
n2:
	inc	cx
	shr	dx,1
	rcr	ax,1
	cmp	dh,63
        jg      n2
	jmp	short n8
n4:
; dh equal 0
	mov	dh,dl
	mov	dl,ah
	mov	ah,al
	mov	al,0
	sub	cx,8
	jmp	n1
n8:
	mov	x.fexp,cx
	mov	x.fhigh,dx
	mov	x.flow,ax
n9:
	endm
divi  macro x,y,z
local d1,d2,d3,d4,d5,d6,d7,d8,d9
; this divides x by y giving z
; y is an integer, making it easier to work with this stuff
; needed for calculating adders
;
; load up the workers
	mov	ax,x.flow
	mov	dx,x.fhigh
        mov     cl,x.fsign
	mov	z.fsign,cl
        mov     cx,x.fexp
        mov     z.fexp,cx
	mov	z.fhigh,0
	mov	z.flow,0
; step one. if either of the guys is zero then the result is zero
	cmp	ax,0
	jne	d1
	cmp	bx,0
	jne	d1
	cmp	dx,0
	jne	d1
	cmp	bp,0
	jne	d1
; here we have a zero output
	jmp	d9
d1:
; for best results, dx:ax should be normalized to left
        test    dh,11000000b
        jnz     d2
        shl    ax,1
        rcl    dx,1
        dec    cx
        jmp    d1
d2:
        mov     z.fexp,cx
        push    ax
        mov     ax,dx
        mov     dx,0
	mov	cx,y
        idiv   cx
; ax has the result, dx the remainder both div by 1000h
        mov   z.fhigh,ax
        mov   ah,dl
        mov   dl,dh
        mov   dh,0
        mov   al,0
        idiv   cx
        mov   byte ptr z.flow+1,al
        add   byte ptr z.fhigh,ah
        adc   byte ptr z.fhigh+1,0
        mov   ah,dl
        mov   dl,dh
        mov   dh,0
        mov   al,0
        idiv   cx
        add   z.flow,ax
        adc   z.fhigh,0
        mov   ah,dl
        mov   dl,dh
        mov   dh,0
        mov   al,0
        idiv   cx
        add   al,7fh
        adc   byte ptr z.flow,ah
        adc   byte ptr z.flow+1,0
        adc   z.fhigh,0
        mov   ah,dl
        mov   dl,dh
        mov   dh,0
        mov   al,0
        idiv   cx
        add   ax,7fffh
        adc   z.flow,0
        adc   z.fhigh,0
        pop   ax
; ax is the /1000h guy
        mov   dx,0
        idiv   cx
        add   z.flow,ax
        adc   z.fhigh,0
        mov   ah,dl
        mov   dl,dh
        mov   dh,0
        mov   al,0
        idiv   cx
        add   al,7fh
        adc   byte ptr z.flow,ah
        adc   byte ptr z.flow+1,0
        adc   z.fhigh,0
        mov   ah,dl
        mov   dl,dh
        mov   dh,0
        mov   al,0
        idiv   cx
        add   ax,7fffh
        adc   z.flow,0
        adc   z.fhigh,0
;
;
        normal z
d9:
   endm
mull macro x,y,z
local m1,m2,m3,m4,m5,m6,m7,m8,m9
; load up the workers
	mov	ax,x.flow
	mov	dx,x.fhigh
	mov	bx,y.flow
	mov	bp,y.fhigh
	mov	z.fsign,1
	mov	z.fexp,0
	mov	z.fhigh,0
	mov	z.flow,0
; step one. if either of the guys is zero then the result is zero
	cmp	ax,0
	jne	m1
	cmp	bx,0
	jne	m1
	cmp	dx,0
	jne	m1
	cmp	bp,0
	jne	m1
; here we have a zero output
	jmp	m9
m1:
; they are not zero
; first add in the exponents
	mov	cx,x.fexp
	add	cx,y.fexp
	mov	z.fexp,cx
; now multiply the two guys out
;(a+b)*(c+d)= ac + ad + bc + bd,
	push	ax
	push	dx
	mov	ax,dx
	mov	cx,bp
	mul	cx
; dx:ax has answer, but has been sent 16 bits to left due to exp
	mov	temphigh,dx
	mov	byte ptr z.fhigh,ah
	mov	byte ptr z.flow+1,al
	pop	ax   ; saved dx from above
	mov	cx,bx
	mul	cx
; dx:ax has result but shifted 8 to left and 8 to right
        add     ax,7fh
        adc     dx,0
        mov     al,ah
        mov     ah,dl
	add	z.flow,ax
        adc     byte ptr z.fhigh,dh
	adc	temphigh,0
	pop	ax
	push	ax
	mov	cx,bp
	mul	cx
        add     ax,7fh
        adc     dx,0
        mov     al,ah
        mov     ah,dl
	add	z.flow,ax
        adc     byte ptr z.fhigh,dh
	adc	temphigh,0
	pop	ax
	mov	cx,bx
	mul	cx
	add	ax,7fffh
	adc	dl,7fh
        adc     byte ptr z.flow,dh
        adc     byte ptr z.flow+1,0
        adc     byte ptr z.fhigh,0
        adc     temphigh,0
; all doen with mul, now must figure the sign of the output
	mov	al,x.fsign
	cmp	al,y.fsign
	je	m6
	mov	z.fsign,-1
m6:
	mov	ax,temphigh
m7:
	cmp	ax,64
	jl	m8
	shr	ax,1
       rcr      byte ptr z.fhigh,1
	rcr	z.flow,1
	inc	z.fexp
	jmp	m7
m8:
	mov	byte ptr z.fhigh+1,al
	normal z
m9:
	endm
aprep macro	x,y
local p1,p2,p3,p4,p5,p6,p7,p8,p9
; this brings two floats to the same exponent
	mov	si,x.fexp
	mov	di,y.fexp
	cmp	si,di
	jl	p1
	jg	p5
	jmp	p9	; they are already equal
p1:
; x is less than y that means that x must be shifted right
; or y must be shifted left
	mov	dx,x.fhigh
	mov	ax,x.flow
	mov	bx,y.fhigh
	mov	cx,y.flow
; start by shifting y to the left
p2:
	cmp	bh,31
	jg	p3
	cmp	si,di
	je	p8
	shl	cx,1
	rcl	bx,1
	dec	di
	jmp	p2
p3:
; have to start shifting x to right
	shr	dx,1
	rcr	ax,1
	inc	si
	cmp	si,di
	je	p8
	jmp	p3
p5:
; y is less than x
	mov	dx,x.fhigh
	mov	ax,x.flow
	mov	bx,y.fhigh
	mov	cx,y.flow
p6:
; shift x to left
	cmp	dh,31
	jg	p7
	cmp	si,di
	je	p8
	shl	ax,1
	rcl	dx,1
	dec	si
	jmp	p6
p7:
; have to start shifting y to right
	shr	bx,1
	rcr	cx,1
	inc	di
	cmp	si,di
	je	p8
	jmp	p7
p8:
	mov	x.fexp,si
	mov	x.fhigh,dx
	mov	x.flow,ax
	mov	y.fexp,di
	mov	y.fhigh,bx
	mov	y.flow,cx
p9:
endm
addd macro x,y,z
local a0,a1,a2,a3,a4,a5,a6,a7,a8,a9
; adds x and y puts in z
; check for zero
	mov	dx,x.fhigh
	mov	ax,x.flow
	cmp	dx,0
	jne	a1
	cmp	ax,0
	jne	a1
; x is zero
	mov	dx,y.fhigh
	mov	ax,y.flow
        mov     cl,y.fsign
	mov	bx,y.fexp
        cmp     dx,0
        jne     a0
        cmp     ax,0
        jne     a0
        mov     z.fexp,0
        mov     z.fsign,1
	mov	z.fhigh,dx
	mov	z.flow,ax
	jmp	a9
a0:
	mov	z.fhigh,dx
	mov	z.flow,ax
	mov	z.fsign,cl
	mov	z.fexp,bx
	jmp	a9
a1:
	mov	bx,y.fhigh
	mov	cx,y.flow
	cmp	bx,0
	jne	a2
	cmp	cx,0
	jne	a2
	mov	dx,x.fhigh
	mov	ax,x.flow
        mov     cl,x.fsign
        mov     bx,x.fexp
        cmp     dx,0
        jne     a0
        cmp     ax,0
        jne     a0
        mov     z.fexp,0
        mov     z.fsign,1
	mov	z.fhigh,dx
	mov	z.flow,ax
	jmp	a9
a2:
; they are not zero aprep will get them in tune
	aprep x,y
	mov	dx,x.fhigh
	mov	ax,x.flow
	mov	si,y.fhigh
	mov	di,y.flow
; dx:ax has one guy, si,di has the other
	mov	bl,x.fsign
	cmp	bl,y.fsign
	jne	a3
; here the signs are the same, the exp are the same, simple add
	add	ax,di
	adc	dx,si
	jmp	a0
a3:
; signs are different
	sub	ax,di
	sbb	dx,si
	cmp	dh,0
	jl 	a4
	jmp	short a6
a4:
; changes the sign
	mov	di,ax
	mov	si,dx
	xor	ax,ax
	xor	dx,dx
	sub	ax,di
	sbb	dx,si
         neg    bl
a6:
        cmp     ax,0
        jne     a7
        cmp     dx,0
        jne     a7
	mov	z.fsign,1
	mov	z.fhigh,00
	mov	z.flow,0
	mov	z.fexp,0
        jmp     short  a9
a7:
	mov	z.fsign,bl
	mov	z.fhigh,dx
	mov	z.flow,ax
	mov	bx,y.fexp
	mov	z.fexp,bx
a9:
	normal z
	endm
;
;
subb macro	x,y,z
; this just subtracts y from x giving z by adding
	neg	y.fsign
	addd x,y,z
	neg	y.fsign
endm
