print macro string
local tstring,estring
   push  si
   lea  si,string
tstring:
   cld
   lodsb
   cmp  al,0
   je   estring
   mov  ah,14
   int  10h
   jmp  tstring
estring:
   pop   cx
endm
locate  macro x,y
          mov      ah,2
          mov      dl,y
          mov      dh,x
          mov      bx,0
          int      10h
endm
cls  macro  col
          mov      ah,7
          mov      al,0
          mov      cx,0
          mov      dx,184fh
          mov      bh,col
          int      10h
endm
cseg segment para public 'CODE'
assume cs:cseg,ds:cseg
          org 100h
enter:    jmp      main     ;skip over data
;                     205,187
;               201      ;186
commline  equ this byte ; this is the parmblock for execute
     db 6
     db '/C OK',13,0,0
parmblock  dw  0
           dw  commline
tailds     dw  0
           dw 5ch
fcb1       dw  0
           dw 6ch
fcb2       dw  0
mscr db    10,10
     db '                    ͻ',13,10
     db '                             OPTIKS Galley Editor        ',13,10
     db '                                Version 1.00             ',13,10
     db '                      Copyright 1987 by Keith P. Graham  ',13,10
     db '                    ͼ',13,10
     db 10,10,10
     db '                         1. Edit an old Galley Sheet',13,10
     db '                         2. Create a new Galley Sheet',13,10
     db '                         3. OPTIKS Graphics Spreadsheet',13,10
     db 10,10,10
     db '                         9. Exit to Dos',13,10
     db 10
     db '                            Desired function: ',13,10
     db 10
     db '              Enter the number of the function; Press return',0
olds db 13,10
     db '                         EDIT an Old Galley Sheet',13,10,10
     db '               What is the name of the old galley sheet?',13,10,10
     db 0
news db 13,10
     db '                         EDIT a New Galley Sheet',13,10,10
     db '               What is the name of the new galley sheet?',13,10,10
     db 0
gname db '          NAME: ',13,10,10,0
filespec db '*.gal',0
filename  db 40,42 dup(0)
char db  0
mess1 db 13,10,'Thank you for using the OPTIKS Galley Editor',13,10,0
mess2 db 13,10,'Press any key to continue',13,10,0
err2  db 'Invalid file name or file not found. Press any key.....',0
err3  db 'File already exists. Press any key.....',0
err4  db 'Error creating file. Press and key.....',0
err5  db 'Not an OPTIKS Galley Sheet file. Press any Key......',0
stack  dw 256 dup(0)
savess  dw  0
savesp  dw  0
cursmode dw 0
handle  dw  0
;
;
;  GAL header record - 512 bytes
;
gal_hbuff db 8 dup(0)    ; 8 bytes compare to header below
;
gal_head db 'KPG-OKG '   ; 8 bytes
gal_body equ this byte
gal_comment1  db 62,63 dup(0)
gal_comment2  db 62,63 dup(0)
gal_comment3  db 62,63 dup(0)
gal_comment4  db 62,63 dup(0)
gal_font1     db 38,39 dup(0)
gal_font2     db 38,39 dup(0)
gal_font3     db 38,39 dup(0)
gal_font4     db 38,39 dup(0)
gal_font5     db 38,39 dup(0)
gal_font6     db 38,39 dup(0)
    end_head = 512+gal_head-$
      db end_head dup(0)
main      proc     near
; clear the screen, and get function
          call     shrink
          mov      ah,3
          int      10h
          mov      cursmode,cx
          cls  1fh
          locate 0,0
          print    mscr
          mov      ah,1
          mov      cx,00ffh
          mov      bx,0
          int      10h
get_char:
          locate   12h,2eh
          mov      ah,1
          int      21h
          push     ax
          mov      ah,4
          mov      bx,0
          int      10h
          pop      ax
          cmp      al,13
          je       action
          cmp      al,27
          jne      not_esc
          jmp      return_to_dos
not_esc:
          mov      char,al
          jmp      get_char
action:
          mov      al,char
          cmp      al,'9'
          jne      not_9
          jmp      return_to_dos
not_9:
          cmp      al,'3'
          jne      not_3
          jmp      call_ok
not_3:
          cmp      al,'1'
          jne      not_1
          jmp      do_old
not_1:
          cmp      al,'2'
          jne      not_2
          jmp      do_new
not_2:
          jmp      get_char
get_head:
; get the input header information
; clear the screen
; display the data in correct locations
;
          jmp     main
do_old:
          cls    07
          locate  0,0
          print    olds
          print    gname
get_oname:
          call     display_dir
          locate 5,14h
          lea      si,filename
          call     getline
; have a line
          cmp      al,13
          je       o1
          jmp      main
o1:
          call     fix_gname
; check the guy in the buffer for a valid file
          lea      dx,filename+1
          mov      ah,3dh
          mov      al,2   ; read and write
          int     21h
          jc      bad_open
          mov     handle,bx
; check to see if it is a gally file
          lea    dx,gal_hbuff
          mov    bx,handle
          mov    ah,3fh
          mov    cx,8
          jc     bad_open
          cmp    ax,8
          jne     bad_file
          lea    si,gal_hbuff
          lea    di,gal_head
          mov    cx,8
          cld
repz      cmpsb
          jne    bad_file
; get the rest of the guy in
          lea    dx,gal_body
          mov    cx,504
          mov    ah,3fh
          int    21h
          jc     bad_file
          cmp    ax,504
         jne     bad_file
          jmp    get_head
bad_file:
          mov      ah,2
          mov      dx,1600h
          mov      bx,0
          int      10h
          print   err5
          mov     ah,0
          int     16h
          jmp     get_oname
bad_open:
          mov      ah,2
          mov      dx,1600h
          mov      bx,0
          int      10h
          print   err2
          mov     ah,0
          int     16h
          jmp     get_oname
do_new:
          cls      07
          locate   0,0
          print    news
          print    gname
get_nname:
          call     display_dir
          locate  5,14h
          lea      si,filename
          call     getline
; have a line
          cmp      al,13
          je       n1
          jmp      main
n1:
; check the guy in the buffer for a valid file
; first does he already exist
          call     fix_gname
          lea      dx,filename+1
          mov      ah,4eh
          mov      cx,0
          int     21h
          jnc     file_exists
          lea      dx,filename+1
          mov      ah,3ch  ; create
          mov      al,0
          mov      cx,0
          int     21h
          jc      bad_create
          mov     handle,ax
; write out a blank header
          mov     cx,512
          lea     dx,gal_head
          mov     ah,40h
          mov     bx,handle
          int     21h
          jc      bad_create
          cmp     ax,cx
          jne     bad_create
          jmp     get_head
bad_create:
          mov      ah,2
          mov      dx,1600h
          mov      bx,0
          int      10h
          print   err4
          mov     ah,0
          int     16h
          jmp     get_nname
file_exists:
          mov      ah,2
          mov      dx,1600h
          mov      bx,0
          int      10h
          print   err3
          mov     ah,0
          int     16h
          jmp     get_nname
fix_gname:
; this puts a .GAL on a file if it doens not have one
          lea     di,filename+1
          mov     cl,filename
          mov     ch,0
          cld
          mov    al,0
repne     scasb
          mov    cx,di
          mov    si,cx
          lea    di,filename+1
          sub    cx,di
          cmp    cx,0
          jle    e_fg
          mov    al,'.'
          cld
repne     scasb
          je   e_fg
          mov   di,si
          dec   di
          mov   ax,'G.'
          stosw
          mov   ax,'LA'
          stosw
          mov   ax,0
         stosw
e_fg:
       ret
display_dir:
          ret
return_to_dos:
; return any open files
          mov     bx,handle
          cmp     bx,0
          je      no_close
          mov     ah,3eh
          int     21h
no_close:
          cls      07
          mov      ah,1
          mov      bx,0
          mov      cx,cursmode
          int      10h
          print    mess1
          int      20h      ; back to dos
call_ok:
          mov      ah,1
          mov      bx,0
          mov      cx,cursmode
          int      10h
   mov   savess,ss
   mov   savesp,sp
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
; find the comspec
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
   cmp   byte ptr es:[di-2],'C'
   jne   env_loop
   cmp   byte ptr es:[di-3],'E'
   jne   env_loop
   cmp   byte ptr es:[di-4],'P'
   jne   env_loop
 ; got the comspec
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
   print mess2
   mov   ah,0
   int   16h
   jmp   main
main      endp
include c:gline.asm
shrink    proc   near
; shrinks down to the last byte
; shrink memory
   mov   ah,4ah
   lea   bx,last_byte
   add   bx,15
   shr   bx,1
   shr   bx,1
   shr   bx,1
   shr   bx,1
   int   21h
          pop    ax
          lea    sp,stack+510
          push   ax
          ret
shrink    endp
last_byte equ this byte
cseg      ends
          end  enter
