;
follows  db 4*tablesize+1 dup(0)
;
     dw   10 dup(0)
last_code  dw  0
;
byte_no  dw 0
;
fill_follow:
     lea   di,follows
     cld
     mov   cx,tablesize+1
     mov   al,13
     mov   ah,' '
ff1:
     stosw
     loop  ff1
     ret
follower:
; this takes a byte in al and converts it to a follower
    mov  bx,last_code
    mov  bh,0
    shl  bx,1
    mov  si,home.child
    mov  dl,home[si].who
    mov  cx,word ptr follows[bx]
    mov  last_code,ax
    mov  follow_sw,0
; check first byte for translation
    cmp  cl,al     ; candidate for follower?
    je   follow1
    cmp  ch,al     ; could be a follower?
    je   follow2
    jmp  no_follow
follow1:
    mov  follow_sw,1
    jmp  replace_f
follow2:
; we have a match on second, but must also update the followers
    mov  follow_sw,2
replace_f:
    cmp   cl,ch
    jne  rf2
    cmp   al,cl
    je    rf1
    mov   ch,al
    jmp   rf2
rf1:
    mov   ch,dl
rf2:
    mov   word ptr follows[bx],cx
    mov  ah,0
    ret
;
no_follow:
; this adjusts the follower table
    mov  ch,cl
    mov  cl,al
    jmp   replace_f
;
