; this is a snake squeeze
print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
cseg segment 'CODE'
   assume cs:cseg,ds:cseg,es:cseg,ss:cseg
   org   100h
entry:
        jmp   start
;
comp = 1
ncomp = 0
   ; 1= compress, 0 = decompress
;
;
;
;
hello  db 'hello',13,10
    db 'Copyright 1989 by Keith P. Graham',13,10,'$'
goodbye db 'Bytes read:    '
rbytes  db '         ',13,10
        db 'Bytes written: '
bwrit   db '         ',13,10
        db 'Codes written: '
cwrit   db '         ',13,10
        db 'Old Out Size:  '
outsz   db '         ',13,10
       db 13,10,'$'
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
error4 db 'Error creating output file.',13,10,'$'
error5 db 'Error Writing File (disk full?)',13,10,'$'
file1     db   65  dup(0)
file_size dw 0
file2     db   65  dup(0)
handlei dw 0
bufferi dw 0
handleo dw 0
buffero dw 0
switch1 db 0
switch2 db 0
nodespace dw 0
bufferloc  dw 0
outloc dw 0
free   dw 0  ; first free guy
out_size  dw  0,0
bitsize   dw 512
bits      dw 9
buck1  dw  0,0
buck2  dw  0,0
buck3  dw  0,0
buck4  dw  0,0
if not comp
obuff db 4096 dup(0)
obuffloc dw 0
endif
start:
    print hello
    call  parse_line
    jc    error_exit
    call  memory_alloc
    jc    error_exit
    call  open_file
    jc    error_exit
    call  create_file
    jc    error_exit
    call  init_nodes
    call  read_file
    jc    error_exit
; set up ES register
    push  es
    mov   es,nodespace
    call  compress
    pop   es
    mov   cx,outloc
    cmp   cx,0
    je    done
    call  write_file
done:
    call  stats
    lea   dx,goodbye
error_exit:
    mov   ax,cs
    mov   ds,ax
    mov   ah,9
    int   21h
    int   20h
include f:snake.asm
stats:
    lea  di,rbytes
    mov  ax,buck1
    mov  dx,buck1+2
    call bin2hex
    lea  di,bwrit
    mov  ax,buck2
    mov  dx,buck2+2
    call bin2hex
    lea  di,cwrit
    mov  ax,buck3
    mov  dx,buck3+2
    call bin2hex
    lea  di,outsz
    mov  ax,buck4
    mov  dx,buck4+2
    add  ax,7
    adc  dx,0
    shr  dx,1
    rcr  ax,1
    shr  dx,1
    rcr  ax,1
    shr  dx,1
    rcr  ax,1
    call bin2hex
    ret
bin2hex:
    mov   cx,10000
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    mov   dx,0
    mov   cx,100
    div   cx
    mov   cl,10
    div   cl
    or    ax,3030h
    stosw
    mov   ax,dx
    div   cl
    or    ax,3030h
    stosw
    ret
;
;
write_file:
; get the file into memory
; cx has the size of file to write
    push  ds
    mov   bx,handleo
    mov   dx,0
    mov   ds,buffero
    mov    ah,40h
    int    21h
    pop    ds
    jc     bad_write
    cmp    ax,cx
    je     good_write
bad_write:
    lea dx,error5
    stc
    ret
good_write:
    clc
    ret
;
;
create_file:
    mov  ax,3c00h
    mov  cx,0
    lea  dx,file2
    int  21h
    jnc  good_create
    lea  dx,error4
    stc
    ret
good_create:
    mov  handleo,ax
    clc
    ret
;
read_file:
; get the file into memory
    push  ds
    mov   bx,handlei
    mov   dx,0
    mov   cx,0ffffh
    mov   ds,bufferi
    mov    ah,3fh
    int    21h
    pop    ds
    jnc    good_read
bad_read:
    lea dx,error3
    stc
    ret
good_read:
    mov   file_size,ax
    mov   bufferloc,0
    add   buck1,ax
    adc   buck1+2,0
    clc
    ret
open_file:
; opens the file for reading
    mov  ax,3d10h
    lea  dx,file1
    int  21h
    jnc  good_open
    lea  dx,error1
    stc
    ret
good_open:
    mov  handlei,ax
    clc
    ret
;
last_byte equ this word
parse_line:
; strategy is you have to scan for switches
; then you look for an infile and an outfile
;
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    mov  di,81h
    mov  bx,0
    cld
pl0:
    mov  al,'/'
repne scasb
    jne  pl2
    mov  byte ptr ds:[di-1],20h
    mov  al,byte ptr ds:[di]
    mov  byte ptr ds:[di],20h
    or   al,32
    mov  switch1[bx],al
    inc  bx
    cmp  cx,0
    jle  pl2
    jmp  pl0
pl2:
    mov  si,81h
    lea  di,file1
    mov  cl,byte ptr ds:[80h]
    mov  ch,0
    cmp  cx,3
    jge  ok_fname
bad_fname:
    lea dx,error1
    stc
    ret
ok_fname:
; set up file
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   ok_fname
    cmp  al,9
    je   ok_fname
parse1:
    stosb
    lodsb
    cmp  al,13
    je   parse2
    cmp  al,20h
    je   parse2
    cmp  al,9
    jne  parse1
parse2:
    mov  ax,0
    stosw
    lea  di,file2
parse3:
    lodsb
    cmp  al,13
    je   bad_fname
    cmp  al,20h
    je   parse3
    cmp  al,9
    je   parse3
parse4:
    stosb
    lodsb
    cmp  al,13
    je   parse5
    cmp  al,20h
    je   parse5
    cmp  al,9
    jne  parse4
parse5:
    mov  ax,0
    stosw
    clc
    ret
;
memory_alloc:
; allocates memory
; shrink
;
    mov  cx,0
    lea  ax,last_byte+512
    add  ax,15
    shr  ax,1
    shr  ax,1
    shr  ax,1
    shr  ax,1
    mov  bx,ds
    add  bx,ax
    mov  ax,4a00h
    int  21h
    jnc  good_shrink
bad_mem:
    lea dx,error2
    stc
    ret
good_shrink:
; allocate a stack
    mov  ah,48h
    mov  bx,1000h ; 2048*16=64k stack
    int  21h
    jc   bad_mem
    pop  bx
    mov  ss,ax
    mov  sp,0fffeh
    push bx
; allocate 64k buffer for file access
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  bufferi,ax
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  buffero,ax
; allocate the nodespace
    mov  ah,48h
    mov  bx,1000h ; 64k for file reading
    int  21h
    jc   bad_mem
    mov  nodespace,ax
    clc
    ret
cseg ends
    end entry
