 ; this program will take the environment and allow simple editing
 ; to be performed.
CSEG	SEGMENT PARA PUBLIC 'CODE'
	ASSUME CS:CSEG,DS:CSEG
	ORG	100H			;SKIP TO END OF THE PSP
ENTPT:	JMP	START			;COM FILE ENTRY ALWAYS AT 100H
envsize  dw  000
envmem   dw  0
environment dw 0
kbbyte  db 0
char1   db 0
char2   db 0
clr1    dw      0200h
clr2    dw      174fh
upleft  dw      0000h
lowright dw      194fh
botscreen dw    1700h
stcursor dw     0000h   ; home position
cursor  dw      0000h   ;row column of cursor
lastcurs dw      0      ; last known cursor position
savcurs  dw 0
attrib  db 07h
insertf db 0
screen  db      '         Graham Systems Environment Edit (EE)',13,10
        db      '       Copyright June 1, 1987 by Keith P. Graham',13,10
        db      10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10
        db      10,10,10,10,10,10
        db      'F1=Help,F2=Save,F3=Quit,F4=Clear,F5=Insert'
        db      ',F6=Delete,F7=0DH,F8=08H,F10=READ ME',1
help1   db      13,10
      db '  The primary purpose of this program is to interactively',13,10
      db '  alter the path and perhaps some other parts of the Environment.',13,10
      db '  Altering the COMSPEC= or other parts of the environment is dangerous!',13,10
      db '     There is no guarantee that this program will work',13,10
      db '     as described under all conditions. I cannot be',13,10
      db '     held responsible for the results of running this',13,10
      db '     program. The DOS environment is not something to',13,10
      db '     fool with.',13,10
      db '  You can change any item in the environment or add a new',13,10
      db '  item by simply moving you cursor to where you want',13,10
      db '  and typing the letters. Although order is not very',13,10
      db '  important, try to keep the COMSPEC= statement first,',13,10
      db '  because this program sometimes looks for that statement',13,10
      db '  to verify that it has indeed found the environment.',13,10
      db '  This program has been tested with DOS 3.3, but I can not',13,10
      db '  say if it will work with all version of DOS. Worst case is',13,10
      db '  that EE will not be able to find a valid environment and',13,10
      db '  either give up or be fooled into thinking that something',13,10
      db '  other than the environment is the environment.',13,10
      db 'Press any key to continue..............',1
help2   db     13,10
      db '  The environment cannot handle blank lines so this program',13,10
      db '  automatically deletes blank lines. The Environment almost',13,10
      db '  always deals in upper case letters. The caps lock key is',13,10
      db '  pushed on by the program for you convenience. PATH= and ',13,10
      db '  most of the standard DOS environment items MUST be entirely',13,10
      db '  in upper case. Dos cannot find the b: drive, only the B:',13,10
      db '  drive. In order to change enviroment lines longer than',13,10
      db '  80 characters, EE splits long lines and puts a ~ in',13,10
      db '  to show the split line. Most Dos functions can not use',13,10
      db '  lines any longer than 80 bytes.',13,10
      db '  You may have "Inherited" Dos in which case the Environment',13,10
      db '  is of limited length. EE checks the size of the environment',13,10
      db '  and will not let you expand beyond the size of the original',13,10
      db '  environment. EE does not know the actual environment size',13,10
      db '  and only makes a guess. It is possible to hang the system',13,10
      db '  in which case you will get the following message:',13,10
      db '  "Memory allocation error - cannot load COMMAND, System halted"',13,10
      db '   You must reboot to get the system going again.',13,10
      db '   The default environmentsize is 160 bytes.',13,10
      db 'Press any key to continue..............',1
help3   db    13,10
      db '  Operation of Keys.',13,10
      db '        F1 - Gives this display',13,10
      db '        F2 - Updates the Environment and leaves EE.',13,10
      db '        F3 - Quits EE without updating the Environment.',13,10
      db '        F4 - Clears the Environment completely.',13,10
      db '        F5 - Inserts a blank line above the cursor line.',13,10
      db '        F6 - Deletes the current line.',13,10
      db '        F7 - The 0DH key - allows you to enter the',13,10
      db '             carriage return character directly.',13,10
      db '        F8 - The 08H key - allows you to enter the',13,10
      db '             backspace character without backspacing.',13,10
      db '        F9 - Redisplays screen. You may have entered more',13,10
      db '             characters than the enviroment can handle.',13,10
      db '             This shows the expected results of EE.',13,10
      db '        F10- Copyright and Advertising',13,10
      db '        ~  - (tilde) joins current line with next line',13,10
      db '             when the screen is saved to get lines longer',13,10
      db '             then 80 bytes',13,10,10
      db 'Press any key to continue..............',1
adv1  db  13,10,10
        db '                Graham Systems Environment Edit (EE)',13,10
        db '                   Special Ed Shoemaker Edition ',13,10
        db '       (C)Copyright June 1, 1987 by Keith P. Graham',13,10
        db '       Please address any comments and an occasional',13,10
        db '       $5.00 for those guilt ridden souls to:',13,10
        db '              Keith P. Graham',13,10
        db '              238 Germonds Rd.',13,10
        db '              W. Nyack, New York 10994',13,10,10
        db       10,10,10,10
        db '                       TANSTAAFL',13,10,10,10
      db 'Press any key to continue..............',1
version db      13,10,'Wrong DOS version. Must be 2.0 or 2.1',13,10,1
enverror db     13,10,'Invalid COMSPEC or environment not found',13,10,1
exitmess db     13,10,'EE completed'
         db     13,10,'$'
line1   db   120 dup(0)
line2   db   120 dup(0)
line3   db   120 dup(0)
line4   db   120 dup(0)
line5   db   120 dup(0)
line6   db   120 dup(0)
line7   db   120 dup(0)
line8   db   120 dup(0)
line9   db   120 dup(0)
line10  db   120 dup(0)
line11   db   120 dup(0)
line12   db   120 dup(0)
line13   db   120 dup(0)
line14   db   120 dup(0)
line15   db   120 dup(0)
line16   db   120 dup(0)
line17   db   120 dup(0)
line18   db   120 dup(0)
line19   db   120 dup(0)
line20  db   120 dup(0)
line21  db   120 dup(0)
line22  db   120 dup(0)
line23  db   120 dup(0)
line24  db   120 dup(0)
linetab dw   line1
        dw   line2
        dw   line3
        dw   line4
        dw   line5
        dw   line6
        dw   line7
        dw   line8
        dw   line9
        dw   line10
        dw   line11
        dw   line12
        dw   line13
        dw   line14
        dw   line15
        dw   line16
        dw   line17
        dw   line18
        dw   line19
        dw   line20
        dw   line21
        dw   line22
        dw   line23
        dw   line24
        dw   0fffh
START	PROC	NEAR
; quick check of dos version
        mov ah,30h
        int 21h
        cmp al,2
        jge okvers
        lea dx,version
        mov  ah,9
        call func9
okvers:
;  begin by setting up the screen so at least we see something before
;  the crash
        call    cls    ; clear the whole screen
; now call the routine to move the env to the data area
        call   movenv
        mov    ax,cs
        mov    ds,ax
        mov    es,ax
        mov     ax,clr1 ; now set up windowing
        mov     upleft,ax
        mov   ax,clr2
        mov   lowright,ax
        call  screenset   ; set up screen
        call    cls    ; clear the window
        call   dispdat
        call   capson
        mov    dx,upleft
        mov    cursor,dx
        mov    lastcurs,dx
        call   locate
getloop:
        call   getchar
        cmp    char2,0
        jne   nofunction
        jmp   function
nofunction:
        mov  al,char1
        cmp  al,13
        jne  no13
         mov  ax,cursor
         mov  lastcurs,ax
         cmp  ax,lowright
         jnl  gohome13
         add  ah,1
         mov  al,0
         jmp  saveloc13
gohome13:
         mov  ax,upleft
saveloc13:
         mov  cursor,ax
         call locate
        jmp    getloop
no13:
        cmp  al,8
        jne  no8
         mov  ax,cursor
        cmp  al,0
        je   backspend
        sub  al,1
         mov  cursor,ax
         call locate
        call   breakout    ; puts bx the column and di the line offset
        call   delete
backspend:
        jmp    getloop
no8:
characteri:
;  in al is the character to insert
;
; we have a character and we must convert that character to
; to a permanent change on the line
        call   breakout    ; puts bx the column and di the line offset
        cmp    insertf,0
        je    noinsert
; first check to make sure we can insert
        cmp  byte ptr [di][79],0
        je   insertgo
        jmp    getloop
insertgo:
        call  insert
noinsert:
        mov    byte ptr ds:[bx][di],al ; put that sucker in there
        call   echo
; now check to the left
lookzero:
        cmp    bx,0
        je     endputchar
        dec    bx
        cmp    byte ptr [di][bx],0
        jne    endputchar
        mov    byte ptr [di][bx],20h
        jmp    lookzero
endputchar:
        jmp    getloop
function:
; control characters
        mov  al,char1
        cmp  al,82 ; insert
        jne  no82
        xor  insertf,1
        jmp    getloop
no82:
        cmp  al,83 ; delete
        jne  no83
        call   breakout    ; puts bx the column and di the line offset
        call   delete
        jmp    getloop
no83:
        cmp  al,71 ; home
        jne  no71
; home button
         mov  ax,upleft
        jmp  fsaveloc
no71:
	cmp  al,79 ; end
        jne  no79
         mov  ax,lowright
        jmp  fsaveloc
no79:
        cmp  al,72 ; up
        jne  no72
        mov  dx,upleft
        mov  ax,cursor
        cmp  dh,ah
        jl  cup
        mov   ah,byte ptr lowright+1
        jmp  fsaveloc
cup:
        dec  ah
        jmp  fsaveloc
no72:
        cmp  al,80 ; down
        jne  no80
        mov  dx,lowright
        mov  ax,cursor
        cmp  ah,dh
        jl  cdown
        mov   ah,byte ptr upleft+1
        jmp  fsaveloc
cdown:
        inc  ah
        jmp  fsaveloc
no80:
 ; check for right cursor
        cmp  al,77 ; right
        jne  no77
        mov  dx,lowright
        mov  ax,cursor
        cmp  al,dl
        jl   cright
        mov  al,0
        cmp  ah,dh
        jl   crightd
        mov   ah,byte ptr upleft+1
        jmp  fsaveloc
crightd:
        inc  ah
        jmp  fsaveloc
cright:
        inc  al
        jmp  fsaveloc
no77:
 ; check for left  cursor
        cmp  al,75 ; left
        jne  no75
        mov  dx,upleft
        mov  ax,cursor
        cmp  al,dl
        jg   cleft
        mov  al,byte ptr lowright
        cmp  ah,dh
        jg   cleftd
        mov   ah,byte ptr lowright+1
        jmp  fsaveloc
cleftd:
        dec  ah
        mov   al,byte ptr lowright
        jmp  fsaveloc
cleft:
        dec  al
        jmp  fsaveloc
fsaveloc:
         mov  cursor,ax
         call locate
        jmp  fexit
no75:
; function keys 59=1 60=2 61=3 62=4 63=5 64=6 65=7 66=8 67=9 68=10
; check to see if it is time to leave
;
;       F3 = quit
        cmp  al,61
        jne  no61
        mov  ax,botscreen
        mov  cursor,ax
        call locate
        lea  dx,exitmess
        mov  ah,9
        int  21h
        jmp  end_prog
no61:
 ;     F2 = save
        cmp  al,60
        jne  no60
        call wenv
        mov  ax,botscreen
        mov  cursor,ax
        call locate
        lea  dx,exitmess
        mov  ah,9
        int  21h
        jmp  end_prog
no60:
;      F3 = help
        cmp  al,59
        jne  no59
        mov  ax,cursor
        mov  savcurs,ax
        call locate
        call cls
        mov  ax,upleft
        mov  cursor,ax
        call locate
        lea  dx,help1
        mov  ah,9
        call func9
        call getchar
        call cls
        mov  ax,upleft
        mov  cursor,ax
        call locate
        lea  dx,help2
        mov  ah,9
        call func9
        call getchar
        call cls
        mov  ax,upleft
        mov  cursor,ax
        call locate
        lea  dx,help3
        mov  ah,9
        call func9
        call getchar
        call cls
        call dispdat
        mov  ax,savcurs
        mov  cursor,ax
        call locate
        jmp  fexit
no59:
;  F10 = advertising
        cmp  al,68
        jne  no68
        mov  ax,cursor
        mov  savcurs,ax
        call cls
        mov  ax,upleft
        mov  cursor,ax
        call locate
        lea  dx,adv1
        mov  ah,9
        call func9
        call getchar
        call cls
        call dispdat
        mov  ax,savcurs
        mov  cursor,ax
        call locate
	jmp  fexit
no68:
; f7 = 0dh character to directly insert
        cmp  al,65
        jne  no65
        mov  al,13
        mov  char1,al
        jmp  characteri
no65:
 ; f8 is the charcter 08h
        cmp  al,66
        jne  no66
        mov  al,8
        mov  char1,al
        jmp  characteri
no66:
 ; f9 is redisplay
        cmp  al,67
        jne  no67
        call  cls
        mov  ax,cursor
        mov  savcurs,ax
        call  dispdat
        mov  ax,savcurs
        mov  cursor,ax
        call  locate
        jmp  fexit
no67:
; f5 is insert a line
        cmp  al,63
        jne  no63
        mov  ax,cursor
        mov  savcurs,ax
        call breakout
; cx has the offset of current line in table
; di has the start if the current line
        lea  si,linetab
        add  si,46 ; 24-1*2=offset into linetab of last entry
        mov  di,si
        std  ; go backwards
        lodsw
        mov  dx,ax
; dx now has the address of the current line in linetab
; di has the last line of linetab
; si has the next to last line
        mov  bx,cx
        shr  cx,1    ;divide by 2
        mov  ax,cx
        mov  cx,23   ; count of valid lines less 1 for starting at 0
        sub  cx,ax
 ; cx has the number of moves to make
       std
       cmp   cx,0
       jg    f63loop
        jmp  fexit
f63loop:
; find the 0fffh that ends the thing
rep     movsw
;       di points to the current entry
;
        mov ax,dx
        stosw
        cld
; now clear the current line
        call breakout
; di has the line
        mov   al,0
        mov   cx,80
        cld
rep     stosb
        call  cls
        call  dispdat
        mov  ax,savcurs
        mov  cursor,ax
        call  locate
        jmp  fexit
no63:
; f6 is delete a line
        cmp  al,64
        jne  no64
        mov  ax,cursor
        mov  savcurs,ax
; first must find which line we are at
        call breakout
; di has the line
        mov   dx,di  ; save for later
        mov   al,0
        mov   cx,80
        cld
rep     stosb
        call  breakout
 ;    cx now has the word offset into the table
        lea   di,linetab
        add   di,cx
        mov   si,di
        inc   si
        inc   si
        shr  cx,1    ;divide by 2
        mov  ax,cx
        mov  cx,23   ; count of valid lines less 1 for starting at 0
        sub  cx,ax
        cld
rep     movsw
        mov  ax,dx
        stosw
        call  cls
        call  dispdat
        mov  ax,savcurs
        mov  cursor,ax
        call  locate
        jmp  fexit
no64:
fexit:
        jmp    getloop
end_prog:
        call capsoff
	int 20h
START	ENDP
cls     proc    near
        push  ax
        mov  al,0
        call   scrolld
        pop  ax
        ret
cls     endp
screenset  proc    near
        push  ax
        push  dx
        mov   dx,stcursor
        mov   cursor,dx
        call  locate
        lea   dx,screen
        mov   ah,9
        call  func9
        pop   dx
        pop   ax
        ret
screenset  endp
locate  proc    near
 ; sets cursor position cursor row,column
        push   ax
        push   bx
        push   cx
        push   dx
        mov    dx,cursor
        mov    bx,0
        mov    ah,2
        int    10h
        pop    dx
        pop  cx
        pop bx
        pop ax
        ret
locate  endp
;proc    proc    near
;proc    endp
Echo     proc    near
 ; echoes character in char1 to screen at current loc and updates cursor
         push  ax
         push  bx
         push cx
         mov  ax,cursor
         mov  lastcurs,ax
         cmp  ax,lowright
         jnl  gohome
         mov  ah,10
         mov  al,char1
         mov  cx,1
         mov  bh,0
         int  10h
         mov  ax,cursor
         mov  lastcurs,ax
         cmp  ax,lowright
         jnl  gohome
         cmp  al,byte ptr lowright
         jl   okcol
         add  ah,1
         mov  al,0
         jmp  saveloc
gohome:
;        mov  ax,upleft
         jmp  saveloc
okcol:
         add  al,1
saveloc:
         mov  cursor,ax
         call locate
         pop   cx
         pop   bx
         pop   ax
         ret
ECHO     endp
getchar proc    near
      ; this waits for a character from the screen
      ; if the character is a single length character it is echoed
      ; and the cursor position is updated and the cursor is relocated
        push ax
        push bx
        push cx
        push dx
        cmp  char2,0ffh
        je   no2
        cmp  char2,0
        je   no2
        mov  al,char2
        mov  char1,al
        mov  char2,0ffh
        jmp  getcecho
no2:
        mov  char1,0
        mov  char2,0ffh
        mov  ah,7
        int  21h
        mov  char1,al
        mov  ah,6
        mov  dl,0ffh
        int  21h
        jnz getcnoecho
        jmp getcecho
getcnoecho:
           ; got a second character from the input
        mov  dl,char1
        mov  char2,dl
        mov  char1,al
        cmp  char2,0
        je   getcne2
        jmp  getcecho
getcne2:
        jmp  getcexit
getcecho:
;       call  echo
getcexit:
        pop   dx
        pop   cx
        pop   bx
        pop   ax
        ret
getchar endp
scrollup proc    near
         mov ah,6
         call scroll
         ret
scrollup endp
scrolld proc    near
         mov ah,7
         call scroll
         ret
scrolld endp
scroll  proc    near
 ; scroll scrolls the screen the number of lines indicated by
 ; al, uses upleft and lowright as locations
 ; ah has the direction 6 = up 7 = low
        push bx
        push cx
        push dx
        mov  cx,upleft
        mov  dx,lowright
        mov  bh,attrib
        mov  bl,0
        int  10h
        pop  dx
        pop  cx
        pop bx
        ret
scroll  endp
movenv  proc near
        push ds
        push es
; find current environment
        mov  dx,word ptr ds:[2ch]
        mov  es,dx
        mov  cx,dx
        mov  dx,word ptr es:[0]
; start at 70h and search up
        sub  cx,70h
        mov  ax,70h
env_look:
        mov  ds,ax
        cmp  word ptr ds:[0],dx
        jne  env_look_bot
; have a nibble, time to see if it is the real thing
        push  cx
        mov  si,0
        mov  di,0
        mov  cx,16
        cld
repe    cmpsb
        pop  cx
        je   got_spec
env_look_bot:
        inc  ax
        loop env_look
; here we have a bad environmnet
        jmp  badenv
got_spec:
; ax has the segment address of the environment
        pop  es
        pop  ds
        jmp  makemove
;
badenv:
        pop  es
        pop  ds
 ; got a nogood environment
        call cls
        lea  dx,enverror
        mov  ah,9
        call func9
        call capsoff
        int  20h
makemove:
        push  ds
; ax has the environment address
        mov  environment,ax
; get the enveronment memory block
        dec  ax
        mov  ds,ax
        mov  bx,word ptr ds:[3]
        mov  cl,4
        shl  bx,cl ; multiply by 16
        mov  es:envmem,bx
        inc  ax
        mov  ds,ax
        mov  si,0
        lea  bx,es:linetab
        mov  di,es:[bx]
        mov  cx,es:envmem
        mov  es:envsize,0
        mov  dx,0
envloop:
        push   cx
        cld
        lodsb
        cmp  al,0
        jne  envst
        cmp  byte ptr [si],0
        je   endenv
        jmp  enewline
enewline2:
        stosb
        mov  al,'~'
        stosb
enewline:
        mov  dx,0
        inc  bx
        inc  bx
        mov  di,es:[bx]
        cmp  di,0fffh
        je   endenv
        jmp  eloope
envst:
        cmp  dx,64
        jg   enewline2
        stosb
        inc dx
eloope:
        add  es:envsize,1
        pop  cx
        loop envloop
        push cx
endenv:
        mov  ax,es:envmem
        mov  es:envsize,ax
        pop  cx
        pop  ds
        ret
movenv  endp
dispdat proc near
        lea   bx,linetab
        mov   si,ds:[bx]
         mov  cx,envsize
         dec  cx
         dec  cx
        mov    dx,upleft
        mov    cursor,dx
        mov    dx,0
        call   locate
disploop:
        push cx
        mov  cx,0
        cld
        inc  dx
        cmp  dx,80
        jng  dno80
        mov  cx,1
        jmp  dispret
dno80:
        lodsb
        cmp al,0
        je dispret
        mov char1,al
        call echo
        jmp enddisp
dispret:
         mov  dx,0
        inc  bx
        inc  bx
        mov  si,ds:[bx]
        cmp  si,0fffh
        je   enddisp2
;       cmp  byte ptr ds:[si],0
;       je   enddisp2
         mov  ax,cursor
         cmp  cx,1
         je   dsaveloc
         cmp  ax,lowright
         jnl  dgohome
         add  ah,1
         mov  al,0
         jmp  dsaveloc
dgohome:
         jmp  enddisp
dsaveloc:
         mov  cursor,ax
         call locate
enddisp:
         pop  cx
         loop disploop
         jmp  gobackdisp
enddisp2:
         pop  cx
gobackdisp:
         ret
dispdat endp
wenv  proc near
        push ds
        push es
        lea  bx,linetab
        mov  es,environment
; es has the environment address
        mov  di,0
        mov  si,[bx]
        mov  cx,envsize
         dec  cx
         dec  cx
        mov  dx,0
wenvloop:
        push   cx
        cmp  dx,79
        jg   wnewline
        cld
        lodsb
        cmp  al,0
        je   wnewline
        cmp  al,'~'
        jne  wenvst
; here we concat the line
        mov  dx,0
        inc  bx
        inc  bx
        mov  si,[bx]
        cmp  si,0fffh
        je   wendenv
        jmp  wloope
wnewline:
        mov  dx,0
        inc  bx
        inc  bx
        mov  si,[bx]
        cmp  si,0fffh
        je   wendenv
        cmp  byte ptr [si],0
        je   wloope
        mov  al,0
wenvst:
        stosb
        inc dx
wloope:
        pop  cx
        loop wenvloop
        push cx
wendenv:
        mov  al,0
        stosb
        stosb
        pop  cx
        pop  es
        pop  ds
        ret
wenv  endp
insert  proc near
        push ax
        push bx
        push cx
        push dx
        push si
        push di
; we must move all the
; characters from cursor on right to the right one byte
; di has the address of the line
; bx has the number of column
;
; the strategy is to start at the end of the line and work
; back until we reach bx
        mov   cx,79
        sub   cx,bx
        add   di,79
        mov   si,di
        dec si
        std   ; go backwards
rep     movsb
inloope:
     ; put the character in the new place
        mov  al,char1
        stosb
; the saved line is good but what about the screen?
        mov    cx,cursor
        mov    savcurs,cx
        mov    cx,0
        cld   ; go forward again
; si has the location of the original byte we put in it -1
        inc   si
        mov   cx,80
        sub   cx,bx
 ; now cx has the number of bytes to the right to fill
        mov   dl,char1
ilooper:
        lodsb
        cmp    al,0
        je    iloopere
        mov    char1,al
        call   echo
        loop   ilooper
iloopere:
        mov    char1,dl  ; just in case we want the last character
        mov    cx,savcurs
        mov    cursor,cx
        call   locate
insertend:
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        pop  ax
        ret
insert  endp
capson  proc near
; get and save the keyboard control word at 40:17
        push ax
        push es
        mov  ax,40h
        mov  es,ax
        mov  al,byte ptr es:[17h]
        mov  kbbyte,al
; or the byte to get the caps on
        or   al,40h
        mov  byte ptr es:[17h],al
        pop  es
        pop  ax
        ret
capson  endp
capsoff proc near
        push ax
        push es
        mov  ax,40h
        mov  es,ax
        mov  al,kbbyte
        mov  byte ptr es:[17h],al
        pop  es
        pop  ax
        ret
capsoff endp
delete  proc near
        push ax
        push bx
        push cx
        push dx
        push si
        push di
; we must move all the
; characters from cursor on right to the right one byte
; di has the address of the line
; bx has the number of column
;
; the strategy is to start at the current place and get to end of line
        mov   cx,80
        sub   cx,bx
; cx now has the number of spaces to move
        add   di,bx  ;di has the start
        mov   si,di
        inc si
        cld   ; go forwards
rep     movsb
; the saved line is good but what about the screen?
        mov    cx,cursor
        mov    savcurs,cx
; si has the location of the original byte we put in it -1
        pop   si   ; entry point di
        push  si   ;get di back to si
        add   si,bx
        mov   cx,80
        sub   cx,bx
 ; now cx has the number of bytes to the right to fill
        mov   dl,char1
dlooper:
        lodsb
        mov    char1,al
        call   echo
        loop   dlooper
dloopere:
        mov    char1,dl  ; just in case we want the last character
        mov    cx,savcurs
        mov    cursor,cx
        call   locate
deleteend:
        pop  di
        pop  si
        pop  dx
        pop  cx
        pop  bx
        pop  ax
        ret
delete  endp
breakout proc near
; convert the cursor position into actual line locations
        push   dx
        mov    dx,cursor
; dh has the row and dl the column?
;  check the row number
        mov    bl,dh
        mov    bh,0
        dec    bx
        dec    bx
; bx has the line number
        add    bx,bx
        mov    cx,bx       ; cx has the word offset into table
; bx has the word offset of the line
        mov    di,word ptr ds:[bx][linetab]
; di has the address of the line
        mov    bl,dl
        mov    bh,0
; bx now has the number of column
        pop     dx
        ret
breakout endp
func9   proc  near
 ; this mimics the dos int 21h function 9 except uses 01h as a stopper
 ;
 ; on entry the ds:dx registers point to the string to display
 ;
        push ax
        push bx
        push dx
        push si
        mov  si,dx
func9loop:
        cld
        lodsb
        cmp  al,1
        je  endfunc9
        cmp  al,13
        jne fno13
; here we must cr
        mov  byte ptr cursor,0
        call locate
        jmp  func9loop
fno13:
        cmp  al,10
        jne  fno10
        mov  ax,cursor
        cmp  ah,byte ptr lowright+1
         jl  fokrow
         mov  ax,upleft
         jmp  f9saveloc
fokrow:
         add  ah,1
f9saveloc:
         mov  cursor,ax
         call locate
        jmp  func9loop
fno10:
        mov  char1,al
        call echo
        jmp  func9loop
endfunc9:
        pop  si
        pop  dx
        pop  bx
        pop  ax
        ret
func9   endp
CSEG	ENDS
	END	ENTPT
