print macro string
 lea  dx,string
 mov  ah,9
 int  21h
 endm
cseg segment para public 'CODE'
assume cs:cseg
       org  100h
enter:
jmp   start
topmem dw 0b000h
mess1  db  'Checking memory',13,10,'$'
mess2  db  'Found usable memory up to '
kcount db  '000K',13,10,'$'
;
start:
; check the command line for a parm
      print  mess1
      cmp     byte ptr ds:[80h],1
      jle     by_com
      cmp     byte ptr ds:[5dh],' '
      je      by_com
      mov     al,byte ptr ds:[5dh]
      cmp     al,'2'
      je      by_com
      cmp     al,'0'
      jne     not_0
      mov     topmem,0a000h
      jmp     by_com
not_0:
      cmp     al,'1'
      jne     not_1
      mov     topmem,0a800h
      jmp     by_com
not_1:
      cmp     al,'3'
      jne     not_3
      mov     topmem,0b800h
      jmp     by_com
not_3:
      cmp     al,'4'
      jne     by_com
      mov     topmem,0c000h
by_com:
; turn off the nmi
      XOR      AX,AX
      OUT      0A0h,AL
; get the top of memory
      MOV      AX,ds:[2]      ; top of memory?
      PUSH      DS
search_loop:
      MOV      BX,0000
      CMP      AX,cs:topmem ;start of video
      JZ      done_search
      MOV      DS,AX
      MOV      ds:[BX],AX
      MOV      CX,ds:[BX]
      CMP      AX,CX
      JNZ     done_search
      MOV      CX,8
      MOV      ES,AX
      XOR      AX,AX
      XOR      DI,DI
rep   STOSW
      MOV      AX,DS
      INC      AX
      JMP      search_loop
done_search:
      MOV      dx,AX
      MOV      AL,80h
      OUT      0a0h,AL
      MOV      AX,dx
      MOV      CL,6
      SHR      AX,CL
      MOV      bx,40h
      MOV      DS,bx
      MOV      BX,13h
      CMP      ds:[BX],AX
      JZ      end_search
      MOV      ds:[BX],AX  ; update the bios memory guy
; dx has the top of memory
; update the memory control blocks
      pop      ds
      sub      dx,ds:[2]      ; top of memory?
; dx has the memory to add
      mov      ax,cs
      sub      ax,1
      push     ds
      mov      ds,ax
      add      word ptr ds:[3],dx
;
end_search:
      POP      DS
      push     ds
      MOV      bx,40h
      MOV      DS,bx
      MOV      BX,13h
      mov      ax,ds:[BX]
      pop      ds
; ax has the top of memory in 16 byte segments
      mov      dx,0
      mov      cx,100
      div      cx
      xchg     ax,dx
      or       dl,30h
      mov      kcount,dl
      mov      cx,10
      div      cl
      or       ax,3030h
      mov      word ptr kcount+1,ax
      print    mess2
      INT      20h
cseg  ends
     end   enter
